/******************************
  Program "prot1_alt.m" compiled by "Cached Murphi Release 5.2.4"

  Murphi Last Modified Date: "May 13 2003"
  Murphi Last Compiled date: "Mar  7 2011"
 ******************************/

/********************
  Parameter
 ********************/
#define MURPHI_VERSION "Cached Murphi Release 5.2.4"
#define MURPHI_DATE "May 13 2003"
#define PROTOCOL_NAME "prot1_alt"
#define BITS_IN_WORLD 1272
#define ALIGN
#define PMURPHIK

/********************
  Include
 ********************/
#include "mu_prolog.inc"

/********************
  Decl declaration
 ********************/

class mu_1_AttackerId: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_AttackerId& val){ return value(val.value());};
  inline operator int() const { return value(); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_AttackerId& val)
    {
      if (val.defined())
	return ( s << mu_1_AttackerId::values[ int(val) - 1 ] );
      else
	return ( s << "Undefined" );
    };

  mu_1_AttackerId (char *name, int os): mu__byte(1, 2, 2, name, os) {};
  mu_1_AttackerId (void): mu__byte(1, 2, 2) {};
  mu_1_AttackerId (int val): mu__byte(1, 2, 2, "Parameter or function result.", 0)
    { operator=(val); };
  char * Name() { return values[ value() -1]; };
  virtual void print()
    {
      if (defined()) cout << name << ':' << values[ value() - 1] << '\n';
      else cout << name << ":Undefined\n";
    };
  void print_statistic() {};
friend int CompareWeight(mu_1_AttackerId& a, mu_1_AttackerId& b)
{
  if (!a.defined() && b.defined())
    return -1;
  else if (a.defined() && !b.defined())
    return 1;
  else
    return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
};
char *mu_1_AttackerId::values[] =
  { "AttackerId_1","AttackerId_2",NULL };

/*** end scalarset declaration ***/
mu_1_AttackerId mu_1_AttackerId_undefined_var;

class mu_1_VictimId: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_VictimId& val){ return value(val.value());};
  inline operator int() const { return value(); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_VictimId& val)
    {
      if (val.defined())
	return ( s << mu_1_VictimId::values[ int(val) - 3 ] );
      else
	return ( s << "Undefined" );
    };

  mu_1_VictimId (char *name, int os): mu__byte(3, 3, 1, name, os) {};
  mu_1_VictimId (void): mu__byte(3, 3, 1) {};
  mu_1_VictimId (int val): mu__byte(3, 3, 1, "Parameter or function result.", 0)
    { operator=(val); };
  char * Name() { return values[ value() -3]; };
  virtual void print()
    {
      if (defined()) cout << name << ':' << values[ value() - 3] << '\n';
      else cout << name << ":Undefined\n";
    };
  void print_statistic() {};
friend int CompareWeight(mu_1_VictimId& a, mu_1_VictimId& b)
{
  if (!a.defined() && b.defined())
    return -1;
  else if (a.defined() && !b.defined())
    return 1;
  else
    return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
};
char *mu_1_VictimId::values[] =
  { "VictimId_1",NULL };

/*** end scalarset declaration ***/
mu_1_VictimId mu_1_VictimId_undefined_var;

class mu_1_AgentId: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_AgentId& val) { return value(val.value()); };
  inline operator int() const { return value(); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_AgentId& val)
    {
      if (val.defined())
	return ( s << mu_1_AgentId::values[ val.indexvalue() ] );
      else
	return ( s << "Undefined" );
    };

  // note thate lb and ub are not used if we have byte compacted state.
  mu_1_AgentId (char *name, int os): mu__byte(0, 2, 2, name, os) {};
  mu_1_AgentId (void): mu__byte(0, 2, 2) {};
  mu_1_AgentId (int val): mu__byte(0, 2, 2, "Parameter or function result.", 0)
    { operator=(val); };
  int indexvalue()
  {
    if ((value() >= 1) && (value() <= 2)) return (value() - 1);
    if ((value() >= 3) && (value() <= 3)) return (value() - 1);
  };
  inline int unionassign(int val)
  {
    if (val >= 0 && val <= 1) return value(val+1);
    if (val >= 2 && val <= 2) return value(val+1);
  };
  char * Name() { return values[ indexvalue() ]; };
friend int CompareWeight(mu_1_AgentId& a, mu_1_AgentId& b)
{
  if (!a.defined() && b.defined())
    return -1;
  else if (a.defined() && !b.defined())
    return 1;
  else
    return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void print()
    {
      if (defined()) cout << name << ':' << values[ indexvalue() ] << '\n';
      else cout << name << ":Undefined\n";
    };
  void print_statistic() {};
};
char *mu_1_AgentId::values[] = {"AttackerId_1","AttackerId_2","VictimId_1",NULL };

/*** end union declaration ***/
mu_1_AgentId mu_1_AgentId_undefined_var;

class mu_1_Location: public mu__long
{
 public:
  inline int operator=(int val) { return mu__long::operator=(val); };
  inline int operator=(const mu_1_Location& val) { return mu__long::operator=((int) val); };
  mu_1_Location (char *name, int os): mu__long(1, 64800, 16, name, os) {};
  mu_1_Location (void): mu__long(1, 64800, 16) {};
  mu_1_Location (int val): mu__long(1, 64800, 16, "Parameter or function result.", 0)
  {
    operator=(val);
  };
  char * Name() { return tsprintf("%d",value()); };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
};

/*** end of subrange decl ***/
mu_1_Location mu_1_Location_undefined_var;

class mu_1_prob: public mu__real
{
 public:
  inline double operator=(double val) { return mu__real::operator=(val); };
  inline double operator=(const mu_1_prob& val) { return mu__real::operator=((double) val); };
  mu_1_prob (char *name, int os): mu__real(10,99,56,name, os) {};
  mu_1_prob (void): mu__real(10,99,56) {};
  mu_1_prob (double val): mu__real(10,99,56,"Parameter or function result.", 0)
  {
    operator=(val);
  };
  char * Name() { return tsprintf("%le",value()); };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
};

/*** end of real decl ***/
mu_1_prob mu_1_prob_undefined_var;

class mu_1_CompromisedLoc
{
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  void set_self(char *n, int os);
  mu_0_boolean mu_loc_found;
  mu_1_CompromisedLoc ( char *n, int os ) { set_self(n,os); };
  mu_1_CompromisedLoc ( void ) {};

  virtual ~mu_1_CompromisedLoc(); 
friend int CompareWeight(mu_1_CompromisedLoc& a, mu_1_CompromisedLoc& b)
  {
    int w;
    w = CompareWeight(a.mu_loc_found, b.mu_loc_found);
    if (w!=0) return w;
  return 0;
}
friend int Compare(mu_1_CompromisedLoc& a, mu_1_CompromisedLoc& b)
  {
    int w;
    w = Compare(a.mu_loc_found, b.mu_loc_found);
    if (w!=0) return w;
  return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    mu_loc_found.MultisetSort();
  }
  void print_statistic()
  {
    mu_loc_found.print_statistic();
  }
  void clear() {
    mu_loc_found.clear();
 };
  void undefine() {
    mu_loc_found.undefine();
 };
  void reset() {
    mu_loc_found.reset();
 };
  void print() {
    mu_loc_found.print();
  };
  void print_diff(state *prevstate) {
    mu_loc_found.print_diff(prevstate);
  };
  void to_state(state *thestate) {
    mu_loc_found.to_state(thestate);
  };
virtual bool isundefined() { Error.Error("Checking undefinedness of a non-base type"); return TRUE;}
virtual bool ismember() { Error.Error("Checking membership for a non-base type"); return TRUE;}
  mu_1_CompromisedLoc& operator= (const mu_1_CompromisedLoc& from) {
    mu_loc_found.value(from.mu_loc_found.value());
    return *this;
  };
};

  void mu_1_CompromisedLoc::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1_CompromisedLoc::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1_CompromisedLoc::set_self(char *n, int os)
{
  name = n;
  mu_loc_found.set_self_2(name, ".loc_found", os + 0 );
}

mu_1_CompromisedLoc::~mu_1_CompromisedLoc()
{
}

/*** end record declaration ***/
mu_1_CompromisedLoc mu_1_CompromisedLoc_undefined_var;

class mu_1_MessageType: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_MessageType& val) { return value(val.value()); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_MessageType& val)
  {
    if (val.defined())
      return ( s << mu_1_MessageType::values[ int(val) - 4] );
    else return ( s << "Undefined" );
  };

  mu_1_MessageType (char *name, int os): mu__byte(4, 5, 2, name, os) {};
  mu_1_MessageType (void): mu__byte(4, 5, 2) {};
  mu_1_MessageType (int val): mu__byte(4, 5, 2, "Parameter or function result.", 0)
  {
     operator=(val);
  };
  char * Name() { return values[ value() -4]; };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
  virtual void print()
  {
    if (defined())
      cout << name << ":" << values[ value() -4] << '\n';
    else
      cout << name << ":Undefined\n";
  };
};

char *mu_1_MessageType::values[] = {"From_Init","From_Resp",NULL };

/*** end of enum declaration ***/
mu_1_MessageType mu_1_MessageType_undefined_var;

class mu_1_Message
{
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  void set_self(char *n, int os);
  mu_1_AgentId mu_source;
  mu_1_AgentId mu_dest;
  mu_1_AgentId mu_key;
  mu_1_MessageType mu_mType;
  mu_1_Location mu_f_a;
  mu_1_Location mu_g_a_b;
  mu_1_Message ( char *n, int os ) { set_self(n,os); };
  mu_1_Message ( void ) {};

  virtual ~mu_1_Message(); 
friend int CompareWeight(mu_1_Message& a, mu_1_Message& b)
  {
    int w;
    w = CompareWeight(a.mu_source, b.mu_source);
    if (w!=0) return w;
    w = CompareWeight(a.mu_dest, b.mu_dest);
    if (w!=0) return w;
    w = CompareWeight(a.mu_key, b.mu_key);
    if (w!=0) return w;
    w = CompareWeight(a.mu_mType, b.mu_mType);
    if (w!=0) return w;
    w = CompareWeight(a.mu_f_a, b.mu_f_a);
    if (w!=0) return w;
    w = CompareWeight(a.mu_g_a_b, b.mu_g_a_b);
    if (w!=0) return w;
  return 0;
}
friend int Compare(mu_1_Message& a, mu_1_Message& b)
  {
    int w;
    w = Compare(a.mu_source, b.mu_source);
    if (w!=0) return w;
    w = Compare(a.mu_dest, b.mu_dest);
    if (w!=0) return w;
    w = Compare(a.mu_key, b.mu_key);
    if (w!=0) return w;
    w = Compare(a.mu_mType, b.mu_mType);
    if (w!=0) return w;
    w = Compare(a.mu_f_a, b.mu_f_a);
    if (w!=0) return w;
    w = Compare(a.mu_g_a_b, b.mu_g_a_b);
    if (w!=0) return w;
  return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    mu_source.MultisetSort();
    mu_dest.MultisetSort();
    mu_key.MultisetSort();
    mu_mType.MultisetSort();
    mu_f_a.MultisetSort();
    mu_g_a_b.MultisetSort();
  }
  void print_statistic()
  {
    mu_source.print_statistic();
    mu_dest.print_statistic();
    mu_key.print_statistic();
    mu_mType.print_statistic();
    mu_f_a.print_statistic();
    mu_g_a_b.print_statistic();
  }
  void clear() {
    mu_source.clear();
    mu_dest.clear();
    mu_key.clear();
    mu_mType.clear();
    mu_f_a.clear();
    mu_g_a_b.clear();
 };
  void undefine() {
    mu_source.undefine();
    mu_dest.undefine();
    mu_key.undefine();
    mu_mType.undefine();
    mu_f_a.undefine();
    mu_g_a_b.undefine();
 };
  void reset() {
    mu_source.reset();
    mu_dest.reset();
    mu_key.reset();
    mu_mType.reset();
    mu_f_a.reset();
    mu_g_a_b.reset();
 };
  void print() {
    mu_source.print();
    mu_dest.print();
    mu_key.print();
    mu_mType.print();
    mu_f_a.print();
    mu_g_a_b.print();
  };
  void print_diff(state *prevstate) {
    mu_source.print_diff(prevstate);
    mu_dest.print_diff(prevstate);
    mu_key.print_diff(prevstate);
    mu_mType.print_diff(prevstate);
    mu_f_a.print_diff(prevstate);
    mu_g_a_b.print_diff(prevstate);
  };
  void to_state(state *thestate) {
    mu_source.to_state(thestate);
    mu_dest.to_state(thestate);
    mu_key.to_state(thestate);
    mu_mType.to_state(thestate);
    mu_f_a.to_state(thestate);
    mu_g_a_b.to_state(thestate);
  };
virtual bool isundefined() { Error.Error("Checking undefinedness of a non-base type"); return TRUE;}
virtual bool ismember() { Error.Error("Checking membership for a non-base type"); return TRUE;}
  mu_1_Message& operator= (const mu_1_Message& from) {
    mu_source.value(from.mu_source.value());
    mu_dest.value(from.mu_dest.value());
    mu_key.value(from.mu_key.value());
    mu_mType.value(from.mu_mType.value());
    mu_f_a.value(from.mu_f_a.value());
    mu_g_a_b.value(from.mu_g_a_b.value());
    return *this;
  };
};

  void mu_1_Message::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1_Message::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1_Message::set_self(char *n, int os)
{
  name = n;
  mu_source.set_self_2(name, ".source", os + 0 );
  mu_dest.set_self_2(name, ".dest", os + 8 );
  mu_key.set_self_2(name, ".key", os + 16 );
  mu_mType.set_self_2(name, ".mType", os + 24 );
  mu_f_a.set_self_2(name, ".f_a", os + 32 );
  mu_g_a_b.set_self_2(name, ".g_a_b", os + 64 );
}

mu_1_Message::~mu_1_Message()
{
}

/*** end record declaration ***/
mu_1_Message mu_1_Message_undefined_var;

class mu_1_AgentStates: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_AgentStates& val) { return value(val.value()); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_AgentStates& val)
  {
    if (val.defined())
      return ( s << mu_1_AgentStates::values[ int(val) - 6] );
    else return ( s << "Undefined" );
  };

  mu_1_AgentStates (char *name, int os): mu__byte(6, 13, 4, name, os) {};
  mu_1_AgentStates (void): mu__byte(6, 13, 4) {};
  mu_1_AgentStates (int val): mu__byte(6, 13, 4, "Parameter or function result.", 0)
  {
     operator=(val);
  };
  char * Name() { return values[ value() -6]; };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
  virtual void print()
  {
    if (defined())
      cout << name << ":" << values[ value() -6] << '\n';
    else
      cout << name << ":Undefined\n";
  };
};

char *mu_1_AgentStates::values[] = {"I_SLEEP","I_WAIT","I_RECV","I_KNOW","R_SLEEP","R_RECV","R_SEND","R_KNOW",NULL };

/*** end of enum declaration ***/
mu_1_AgentStates mu_1_AgentStates_undefined_var;

class mu_1_Roles: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1_Roles& val) { return value(val.value()); };
  static char *values[];
  friend ostream& operator<< (ostream& s, mu_1_Roles& val)
  {
    if (val.defined())
      return ( s << mu_1_Roles::values[ int(val) - 14] );
    else return ( s << "Undefined" );
  };

  mu_1_Roles (char *name, int os): mu__byte(14, 15, 2, name, os) {};
  mu_1_Roles (void): mu__byte(14, 15, 2) {};
  mu_1_Roles (int val): mu__byte(14, 15, 2, "Parameter or function result.", 0)
  {
     operator=(val);
  };
  char * Name() { return values[ value() -14]; };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
  virtual void print()
  {
    if (defined())
      cout << name << ":" << values[ value() -14] << '\n';
    else
      cout << name << ":Undefined\n";
  };
};

char *mu_1_Roles::values[] = {"initiator","responder",NULL };

/*** end of enum declaration ***/
mu_1_Roles mu_1_Roles_undefined_var;

class mu_1_Attacker
{
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  void set_self(char *n, int os);
  mu_1_Roles mu_role;
  mu_1_AgentStates mu_state;
  mu_1_AgentId mu_other;
  mu_1_Location mu_location;
  mu_1_Attacker ( char *n, int os ) { set_self(n,os); };
  mu_1_Attacker ( void ) {};

  virtual ~mu_1_Attacker(); 
friend int CompareWeight(mu_1_Attacker& a, mu_1_Attacker& b)
  {
    int w;
    w = CompareWeight(a.mu_role, b.mu_role);
    if (w!=0) return w;
    w = CompareWeight(a.mu_state, b.mu_state);
    if (w!=0) return w;
    w = CompareWeight(a.mu_other, b.mu_other);
    if (w!=0) return w;
    w = CompareWeight(a.mu_location, b.mu_location);
    if (w!=0) return w;
  return 0;
}
friend int Compare(mu_1_Attacker& a, mu_1_Attacker& b)
  {
    int w;
    w = Compare(a.mu_role, b.mu_role);
    if (w!=0) return w;
    w = Compare(a.mu_state, b.mu_state);
    if (w!=0) return w;
    w = Compare(a.mu_other, b.mu_other);
    if (w!=0) return w;
    w = Compare(a.mu_location, b.mu_location);
    if (w!=0) return w;
  return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    mu_role.MultisetSort();
    mu_state.MultisetSort();
    mu_other.MultisetSort();
    mu_location.MultisetSort();
  }
  void print_statistic()
  {
    mu_role.print_statistic();
    mu_state.print_statistic();
    mu_other.print_statistic();
    mu_location.print_statistic();
  }
  void clear() {
    mu_role.clear();
    mu_state.clear();
    mu_other.clear();
    mu_location.clear();
 };
  void undefine() {
    mu_role.undefine();
    mu_state.undefine();
    mu_other.undefine();
    mu_location.undefine();
 };
  void reset() {
    mu_role.reset();
    mu_state.reset();
    mu_other.reset();
    mu_location.reset();
 };
  void print() {
    mu_role.print();
    mu_state.print();
    mu_other.print();
    mu_location.print();
  };
  void print_diff(state *prevstate) {
    mu_role.print_diff(prevstate);
    mu_state.print_diff(prevstate);
    mu_other.print_diff(prevstate);
    mu_location.print_diff(prevstate);
  };
  void to_state(state *thestate) {
    mu_role.to_state(thestate);
    mu_state.to_state(thestate);
    mu_other.to_state(thestate);
    mu_location.to_state(thestate);
  };
virtual bool isundefined() { Error.Error("Checking undefinedness of a non-base type"); return TRUE;}
virtual bool ismember() { Error.Error("Checking membership for a non-base type"); return TRUE;}
  mu_1_Attacker& operator= (const mu_1_Attacker& from) {
    mu_role.value(from.mu_role.value());
    mu_state.value(from.mu_state.value());
    mu_other.value(from.mu_other.value());
    mu_location.value(from.mu_location.value());
    return *this;
  };
};

  void mu_1_Attacker::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1_Attacker::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1_Attacker::set_self(char *n, int os)
{
  name = n;
  mu_role.set_self_2(name, ".role", os + 0 );
  mu_state.set_self_2(name, ".state", os + 8 );
  mu_other.set_self_2(name, ".other", os + 16 );
  mu_location.set_self_2(name, ".location", os + 24 );
}

mu_1_Attacker::~mu_1_Attacker()
{
}

/*** end record declaration ***/
mu_1_Attacker mu_1_Attacker_undefined_var;

class mu_1_Conversation
{
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  void set_self(char *n, int os);
  mu_1_Roles mu_role;
  mu_1_AgentId mu_other;
  mu_1_AgentStates mu_state;
  mu_1_Conversation ( char *n, int os ) { set_self(n,os); };
  mu_1_Conversation ( void ) {};

  virtual ~mu_1_Conversation(); 
friend int CompareWeight(mu_1_Conversation& a, mu_1_Conversation& b)
  {
    int w;
    w = CompareWeight(a.mu_role, b.mu_role);
    if (w!=0) return w;
    w = CompareWeight(a.mu_other, b.mu_other);
    if (w!=0) return w;
    w = CompareWeight(a.mu_state, b.mu_state);
    if (w!=0) return w;
  return 0;
}
friend int Compare(mu_1_Conversation& a, mu_1_Conversation& b)
  {
    int w;
    w = Compare(a.mu_role, b.mu_role);
    if (w!=0) return w;
    w = Compare(a.mu_other, b.mu_other);
    if (w!=0) return w;
    w = Compare(a.mu_state, b.mu_state);
    if (w!=0) return w;
  return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    mu_role.MultisetSort();
    mu_other.MultisetSort();
    mu_state.MultisetSort();
  }
  void print_statistic()
  {
    mu_role.print_statistic();
    mu_other.print_statistic();
    mu_state.print_statistic();
  }
  void clear() {
    mu_role.clear();
    mu_other.clear();
    mu_state.clear();
 };
  void undefine() {
    mu_role.undefine();
    mu_other.undefine();
    mu_state.undefine();
 };
  void reset() {
    mu_role.reset();
    mu_other.reset();
    mu_state.reset();
 };
  void print() {
    mu_role.print();
    mu_other.print();
    mu_state.print();
  };
  void print_diff(state *prevstate) {
    mu_role.print_diff(prevstate);
    mu_other.print_diff(prevstate);
    mu_state.print_diff(prevstate);
  };
  void to_state(state *thestate) {
    mu_role.to_state(thestate);
    mu_other.to_state(thestate);
    mu_state.to_state(thestate);
  };
virtual bool isundefined() { Error.Error("Checking undefinedness of a non-base type"); return TRUE;}
virtual bool ismember() { Error.Error("Checking membership for a non-base type"); return TRUE;}
  mu_1_Conversation& operator= (const mu_1_Conversation& from) {
    mu_role.value(from.mu_role.value());
    mu_other.value(from.mu_other.value());
    mu_state.value(from.mu_state.value());
    return *this;
  };
};

  void mu_1_Conversation::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1_Conversation::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1_Conversation::set_self(char *n, int os)
{
  name = n;
  mu_role.set_self_2(name, ".role", os + 0 );
  mu_other.set_self_2(name, ".other", os + 8 );
  mu_state.set_self_2(name, ".state", os + 16 );
}

mu_1_Conversation::~mu_1_Conversation()
{
}

/*** end record declaration ***/
mu_1_Conversation mu_1_Conversation_undefined_var;

class mu_1__type_0
{
 public:
  mu_1_Conversation array[ 2 ];
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self( char *n, int os);
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  mu_1__type_0 (char *n, int os) { set_self(n, os); };
  mu_1__type_0 ( void ) {};
  virtual ~mu_1__type_0 ();
  mu_1_Conversation& operator[] (int index) /* const */
  {
#ifndef NO_RUN_TIME_CHECKING
    if ( ( index >= 1 ) && ( index <= 2 ) )
      return array[ index - 1 ];
    else
      {
	if (index==UNDEFVAL) 
	  Error.Error("Indexing to %s using an undefined value.", name);
	else
	  Error.Error("Funny index value %d for %s: AttackerId is internally represented from 2 to 1.\nInternal Error in Type checking.",index, name);
	return array[0];
      }
#else
    return array[ index - 1 ];
#endif
  };
  mu_1__type_0& operator= (const mu_1__type_0& from)
  {
    for (int i = 0; i < 2; i++)
      array[i] = from.array[i];
    return *this;
  }

friend int CompareWeight(mu_1__type_0& a, mu_1__type_0& b)
  {
    return 0;
  }
friend int Compare(mu_1__type_0& a, mu_1__type_0& b)
  {
    int w;
    for (int i=0; i<2; i++) {
      w = Compare(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    for (int i=0; i<2; i++)
      array[i].MultisetSort();
  }
  void print_statistic()
  {
    for (int i=0; i<2; i++)
      array[i].print_statistic();
  }
  void clear() { for (int i = 0; i < 2; i++) array[i].clear(); };

  void undefine() { for (int i = 0; i < 2; i++) array[i].undefine(); };

  void reset() { for (int i = 0; i < 2; i++) array[i].reset(); };

  void to_state(state *thestate)
  {
    for (int i = 0; i < 2; i++)
      array[i].to_state(thestate);
  };

  void print()
  {
    for (int i = 0; i < 2; i++)
      array[i].print(); };

  void print_diff(state *prevstate)
  {
    for (int i = 0; i < 2; i++)
      array[i].print_diff(prevstate);
  };
};

  void mu_1__type_0::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1__type_0::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1__type_0::set_self( char *n, int os)
  {
    int i=0;
    name = n;
array[i].set_self_ar(n,"AttackerId_1", i * 24 + os);i++;
array[i].set_self_ar(n,"AttackerId_2", i * 24 + os);i++;
}
mu_1__type_0::~mu_1__type_0()
{
}
/*** end array declaration ***/
mu_1__type_0 mu_1__type_0_undefined_var;

class mu_1_Victim
{
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  void set_self(char *n, int os);
  mu_1_Location mu_location;
  mu_1__type_0 mu_conversation_list;
  mu_1_Victim ( char *n, int os ) { set_self(n,os); };
  mu_1_Victim ( void ) {};

  virtual ~mu_1_Victim(); 
friend int CompareWeight(mu_1_Victim& a, mu_1_Victim& b)
  {
    int w;
    w = CompareWeight(a.mu_location, b.mu_location);
    if (w!=0) return w;
    w = CompareWeight(a.mu_conversation_list, b.mu_conversation_list);
    if (w!=0) return w;
  return 0;
}
friend int Compare(mu_1_Victim& a, mu_1_Victim& b)
  {
    int w;
    w = Compare(a.mu_location, b.mu_location);
    if (w!=0) return w;
    w = Compare(a.mu_conversation_list, b.mu_conversation_list);
    if (w!=0) return w;
  return 0;
}
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    mu_location.MultisetSort();
    mu_conversation_list.MultisetSort();
  }
  void print_statistic()
  {
    mu_location.print_statistic();
    mu_conversation_list.print_statistic();
  }
  void clear() {
    mu_location.clear();
    mu_conversation_list.clear();
 };
  void undefine() {
    mu_location.undefine();
    mu_conversation_list.undefine();
 };
  void reset() {
    mu_location.reset();
    mu_conversation_list.reset();
 };
  void print() {
    mu_location.print();
    mu_conversation_list.print();
  };
  void print_diff(state *prevstate) {
    mu_location.print_diff(prevstate);
    mu_conversation_list.print_diff(prevstate);
  };
  void to_state(state *thestate) {
    mu_location.to_state(thestate);
    mu_conversation_list.to_state(thestate);
  };
virtual bool isundefined() { Error.Error("Checking undefinedness of a non-base type"); return TRUE;}
virtual bool ismember() { Error.Error("Checking membership for a non-base type"); return TRUE;}
  mu_1_Victim& operator= (const mu_1_Victim& from) {
    mu_location.value(from.mu_location.value());
    mu_conversation_list = from.mu_conversation_list;
    return *this;
  };
};

  void mu_1_Victim::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1_Victim::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1_Victim::set_self(char *n, int os)
{
  name = n;
  mu_location.set_self_2(name, ".location", os + 0 );
  mu_conversation_list.set_self_2(name, ".conversation_list", os + 32 );
}

mu_1_Victim::~mu_1_Victim()
{
}

/*** end record declaration ***/
mu_1_Victim mu_1_Victim_undefined_var;

/*** begin multiset declaration ***/
class mu_1__type_1_id: public mu__byte
{
 public:
  inline int operator=(int val) { return value(val); };
  inline int operator=(const mu_1__type_1_id& val) { return value(val.value()); };
  inline operator int() const { return value(); };
  mu_1__type_1_id () : mu__byte(0,9,0) {};
  mu_1__type_1_id (int val) : mu__byte(0,9,0, "Parameter or function result.",0) {operator=(val); };
  char * Name() { return tsprintf("%d", value()); };
};
class mu_1__type_1
{
 public:
  mu_1_Message array[ 10 ];
  int max_size;
  int current_size;
 public:
  mu_0_boolean valid[ 10 ];
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self( char *n, int os);
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  mu_1__type_1 (char *n, int os): current_size(0), max_size(0) { set_self(n, os); };
  mu_1__type_1 ( void ): current_size(0), max_size(0) {};
  virtual ~mu_1__type_1 ();
  mu_1_Message& operator[] (int index) /* const */
  {
    if ((index >= 0) && (index <= 9) && valid[index].value())
      return array[ index ];
    else {
      Error.Error("Internal Error::%d not in index range of %s.", index, name);
      return array[0];
    }
  };
  mu_1__type_1& operator= (const mu_1__type_1& from)
  {
    for (int i = 0; i < 10; i++)
    {
       array[i] = from.array[i];
       valid[i].value(from.valid[i].value());
    };
    current_size = from.get_current_size();
    return *this;
  }

friend int CompareWeight(mu_1__type_1& a, mu_1__type_1& b)
  {
    return 0;
  }
friend int Compare(mu_1__type_1& a, mu_1__type_1& b)
  {
    int w;
    for (int i=0; i<10; i++) {
      w = Compare(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  void clear() { for (int i = 0; i < 10; i++) { array[i].undefine(); valid[i].value(FALSE); } current_size = 0; };

  void undefine() { for (int i = 0; i < 10; i++) { array[i].undefine(); valid[i].value(FALSE); } current_size = 0; };

  void reset() { for (int i = 0; i < 10; i++) { array[i].undefine(); valid[i].value(FALSE); } current_size = 0; };

  void to_state(state *thestate)
  {
    for (int i = 0; i < 10; i++)
     {
       array[i].to_state(thestate);
       valid[i].to_state(thestate);
     }
  };

  int get_current_size() const  {
    int tmp = 0;
    for (int i = 0; i < 10; i++)
      if (valid[i].value()) tmp++;
    return tmp;
  };

   void update_size()
  {
    current_size = 0;
    for (int i = 0; i < 10; i++)
      if (valid[i].value()) current_size++;
    if (max_size<current_size) max_size = current_size;
  };

   inline bool in(const mu_1__type_1_id& id)
  { return valid[(int)id].value(); }
  void print()
  {
    for (int i = 0; i < 10; i++)
      if (valid[i].value())
	array[i].print();
  };

  void print_statistic()
  {
    cout << "	The maximum size for the multiset \"" 
	 << name << "\" is: " << max_size << ".\n"; 
  };
  void print_diff(state *prevstate)
  {
    bool prevvalid;
    static state temp;
    StateCopy(&temp, workingstate);
    for (int i = 0; i < 10; i++)
      {
	StateCopy(workingstate, prevstate);
	prevvalid = valid[i].value();
	StateCopy(workingstate, &temp);
	if (prevvalid && !valid[i].value())
	  array[i].print();
	if (!prevvalid && valid[i].value())
	  array[i].print();
	if (prevvalid && valid[i].value())
	  array[i].print_diff(prevstate);
      }
  };
  int multisetadd(const mu_1_Message &element)
  {
    update_size();
    if (current_size >= 10) Error.Error("Maximum size of MultiSet (%s) exceeded.",name);
    int i;
    for (i = 0; i < 10; i++)
      if (!valid[i].value())
	{
	  array[i] = element;
	  valid[i].value(TRUE);
	  break;
	}
    current_size++;
    return i;
  };
  void multisetremove(const mu_1__type_1_id &id)
  {
    update_size();
    if (!valid[(int)id].value()) Error.Error("Internal Error: Illegal Multiset element selected.");
    valid[(int)id].value(FALSE);
    array[(int)id].undefine();
    current_size--;
  };
  void MultisetSort()
  {
    static mu_1_Message temp;

    // compact
    int i,j;
    for (i = 0, j = 0; i < 10; i++)
      if (valid[i].value())
	{
	  if (j!=i)
	    array[j++] = array[i];
	  else
	    j++;
	}
    if (j != current_size) current_size = j;
    for (i = j; i < 10; i++)
      array[i].undefine();
    for (i = 0; i < j; i++)
      valid[i].value(TRUE);
    for (i = j; i < 10; i++)
      valid[i].value(FALSE);

    // bubble sort
    for (i = 0; i < current_size; i++)
      for (j = i+1; j < current_size; j++)
	if (Compare(array[i],array[j])>0)
	  {
	    temp = array[i];
	    array[i] = array[j];
	    array[j] = temp;
	  }
  }
};

  void mu_1__type_1::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1__type_1::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1__type_1::set_self( char *n, int os)
{
  int i,k;
  name = n;
  for(i = 0; i < 10; i++)
    array[i].set_self(tsprintf("%s{%d}", n,i), i * 96 + os);
  k = os + i * 96;
  for(i = 0; i < 10; i++)
    valid[i].set_self("", i * 8 + k);
};
mu_1__type_1::~mu_1__type_1()
{
}
/*** end multiset declaration ***/
mu_1__type_1 mu_1__type_1_undefined_var;

class mu_1__type_2
{
 public:
  mu_1_Attacker array[ 2 ];
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self( char *n, int os);
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  mu_1__type_2 (char *n, int os) { set_self(n, os); };
  mu_1__type_2 ( void ) {};
  virtual ~mu_1__type_2 ();
  mu_1_Attacker& operator[] (int index) /* const */
  {
#ifndef NO_RUN_TIME_CHECKING
    if ( ( index >= 1 ) && ( index <= 2 ) )
      return array[ index - 1 ];
    else
      {
	if (index==UNDEFVAL) 
	  Error.Error("Indexing to %s using an undefined value.", name);
	else
	  Error.Error("Funny index value %d for %s: AttackerId is internally represented from 2 to 1.\nInternal Error in Type checking.",index, name);
	return array[0];
      }
#else
    return array[ index - 1 ];
#endif
  };
  mu_1__type_2& operator= (const mu_1__type_2& from)
  {
    for (int i = 0; i < 2; i++)
      array[i] = from.array[i];
    return *this;
  }

friend int CompareWeight(mu_1__type_2& a, mu_1__type_2& b)
  {
    return 0;
  }
friend int Compare(mu_1__type_2& a, mu_1__type_2& b)
  {
    int w;
    for (int i=0; i<2; i++) {
      w = Compare(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    for (int i=0; i<2; i++)
      array[i].MultisetSort();
  }
  void print_statistic()
  {
    for (int i=0; i<2; i++)
      array[i].print_statistic();
  }
  void clear() { for (int i = 0; i < 2; i++) array[i].clear(); };

  void undefine() { for (int i = 0; i < 2; i++) array[i].undefine(); };

  void reset() { for (int i = 0; i < 2; i++) array[i].reset(); };

  void to_state(state *thestate)
  {
    for (int i = 0; i < 2; i++)
      array[i].to_state(thestate);
  };

  void print()
  {
    for (int i = 0; i < 2; i++)
      array[i].print(); };

  void print_diff(state *prevstate)
  {
    for (int i = 0; i < 2; i++)
      array[i].print_diff(prevstate);
  };
};

  void mu_1__type_2::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1__type_2::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1__type_2::set_self( char *n, int os)
  {
    int i=0;
    name = n;
array[i].set_self_ar(n,"AttackerId_1", i * 56 + os);i++;
array[i].set_self_ar(n,"AttackerId_2", i * 56 + os);i++;
}
mu_1__type_2::~mu_1__type_2()
{
}
/*** end array declaration ***/
mu_1__type_2 mu_1__type_2_undefined_var;

class mu_1__type_3
{
 public:
  mu_1_Victim array[ 1 ];
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self( char *n, int os);
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  mu_1__type_3 (char *n, int os) { set_self(n, os); };
  mu_1__type_3 ( void ) {};
  virtual ~mu_1__type_3 ();
  mu_1_Victim& operator[] (int index) /* const */
  {
#ifndef NO_RUN_TIME_CHECKING
    if ( ( index >= 3 ) && ( index <= 3 ) )
      return array[ index - 3 ];
    else
      {
	if (index==UNDEFVAL) 
	  Error.Error("Indexing to %s using an undefined value.", name);
	else
	  Error.Error("Funny index value %d for %s: VictimId is internally represented from 3 to 3.\nInternal Error in Type checking.",index, name);
	return array[0];
      }
#else
    return array[ index - 3 ];
#endif
  };
  mu_1__type_3& operator= (const mu_1__type_3& from)
  {
      array[0] = from.array[0];
    return *this;
  }

friend int CompareWeight(mu_1__type_3& a, mu_1__type_3& b)
  {
    int w;
    for (int i=0; i<1; i++) {
      w = CompareWeight(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
friend int Compare(mu_1__type_3& a, mu_1__type_3& b)
  {
    int w;
    for (int i=0; i<1; i++) {
      w = Compare(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    for (int i=0; i<1; i++)
      array[i].MultisetSort();
  }
  void print_statistic()
  {
    for (int i=0; i<1; i++)
      array[i].print_statistic();
  }
  void clear() { for (int i = 0; i < 1; i++) array[i].clear(); };

  void undefine() { for (int i = 0; i < 1; i++) array[i].undefine(); };

  void reset() { for (int i = 0; i < 1; i++) array[i].reset(); };

  void to_state(state *thestate)
  {
    for (int i = 0; i < 1; i++)
      array[i].to_state(thestate);
  };

  void print()
  {
    for (int i = 0; i < 1; i++)
      array[i].print(); };

  void print_diff(state *prevstate)
  {
    for (int i = 0; i < 1; i++)
      array[i].print_diff(prevstate);
  };
};

  void mu_1__type_3::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1__type_3::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1__type_3::set_self( char *n, int os)
  {
    int i=0;
    name = n;
array[i].set_self_ar(n,"VictimId_1", i * 80 + os);i++;
}
mu_1__type_3::~mu_1__type_3()
{
}
/*** end array declaration ***/
mu_1__type_3 mu_1__type_3_undefined_var;

class mu_1__type_4
{
 public:
  mu_1_CompromisedLoc array[ 1 ];
 public:
  char *name;
  char longname[BUFFER_SIZE/4];
  void set_self( char *n, int os);
  void set_self_2( char *n, char *n2, int os);
  void set_self_ar( char *n, char *n2, int os);
  mu_1__type_4 (char *n, int os) { set_self(n, os); };
  mu_1__type_4 ( void ) {};
  virtual ~mu_1__type_4 ();
  mu_1_CompromisedLoc& operator[] (int index) /* const */
  {
#ifndef NO_RUN_TIME_CHECKING
    if ( ( index >= 3 ) && ( index <= 3 ) )
      return array[ index - 3 ];
    else
      {
	if (index==UNDEFVAL) 
	  Error.Error("Indexing to %s using an undefined value.", name);
	else
	  Error.Error("Funny index value %d for %s: VictimId is internally represented from 3 to 3.\nInternal Error in Type checking.",index, name);
	return array[0];
      }
#else
    return array[ index - 3 ];
#endif
  };
  mu_1__type_4& operator= (const mu_1__type_4& from)
  {
      array[0] = from.array[0];
    return *this;
  }

friend int CompareWeight(mu_1__type_4& a, mu_1__type_4& b)
  {
    int w;
    for (int i=0; i<1; i++) {
      w = CompareWeight(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
friend int Compare(mu_1__type_4& a, mu_1__type_4& b)
  {
    int w;
    for (int i=0; i<1; i++) {
      w = Compare(a.array[i], b.array[i]);
      if (w!=0) return w;
    }
    return 0;
  }
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort()
  {
    for (int i=0; i<1; i++)
      array[i].MultisetSort();
  }
  void print_statistic()
  {
    for (int i=0; i<1; i++)
      array[i].print_statistic();
  }
  void clear() { for (int i = 0; i < 1; i++) array[i].clear(); };

  void undefine() { for (int i = 0; i < 1; i++) array[i].undefine(); };

  void reset() { for (int i = 0; i < 1; i++) array[i].reset(); };

  void to_state(state *thestate)
  {
    for (int i = 0; i < 1; i++)
      array[i].to_state(thestate);
  };

  void print()
  {
    for (int i = 0; i < 1; i++)
      array[i].print(); };

  void print_diff(state *prevstate)
  {
    for (int i = 0; i < 1; i++)
      array[i].print_diff(prevstate);
  };
};

  void mu_1__type_4::set_self_ar( char *n1, char *n2, int os ) {
    int l1 = strlen(n1), l2 = strlen(n2);
    strcpy( longname, n1 );
    longname[l1] = '[';
    strcpy( longname+l1+1, n2 );
    longname[l1+l2+1] = ']';
    longname[l1+l2+2] = 0;
    set_self( longname, os );
  };
  void mu_1__type_4::set_self_2( char *n1, char *n2, int os ) {
    strcpy( longname, n1 );
    strcat( longname, n2 );
    set_self( longname, os );
  };
void mu_1__type_4::set_self( char *n, int os)
  {
    int i=0;
    name = n;
array[i].set_self_ar(n,"VictimId_1", i * 8 + os);i++;
}
mu_1__type_4::~mu_1__type_4()
{
}
/*** end array declaration ***/
mu_1__type_4 mu_1__type_4_undefined_var;

class mu_1__type_5: public mu__long
{
 public:
  inline int operator=(int val) { return mu__long::operator=(val); };
  inline int operator=(const mu_1__type_5& val) { return mu__long::operator=((int) val); };
  mu_1__type_5 (char *name, int os): mu__long(1, 64800, 16, name, os) {};
  mu_1__type_5 (void): mu__long(1, 64800, 16) {};
  mu_1__type_5 (int val): mu__long(1, 64800, 16, "Parameter or function result.", 0)
  {
    operator=(val);
  };
  char * Name() { return tsprintf("%d",value()); };
  virtual void Permute(PermSet& Perm, int i);
  virtual void SimpleCanonicalize(PermSet& Perm);
  virtual void Canonicalize(PermSet& Perm);
  virtual void SimpleLimit(PermSet& Perm);
  virtual void ArrayLimit(PermSet& Perm);
  virtual void Limit(PermSet& Perm);
  virtual void MultisetLimit(PermSet& Perm);
  virtual void MultisetSort() {};
  void print_statistic() {};
};

/*** end of subrange decl ***/
mu_1__type_5 mu_1__type_5_undefined_var;

const int mu_NumAttackers = 2;
const int mu_NumVictims = 1;
const int mu_NetworkSize = 10;
const int mu_MaxSteps = 60;
const double mu_Threshold = +1.000000e-04;
const int mu_MaxLocations = 64800;
const int mu_NumConversations = 2;
const int mu_Encryption_OK = 1;
const int mu_Authentication_OK = 1;
const int mu_Hashing_OK = 1;
const int mu_AttackerId_1 = 1;
const int mu_AttackerId_2 = 2;
const int mu_VictimId_1 = 3;
const int mu_From_Init = 4;
const int mu_From_Resp = 5;
const int mu_I_SLEEP = 6;
const int mu_I_WAIT = 7;
const int mu_I_RECV = 8;
const int mu_I_KNOW = 9;
const int mu_R_SLEEP = 10;
const int mu_R_RECV = 11;
const int mu_R_SEND = 12;
const int mu_R_KNOW = 13;
const int mu_initiator = 14;
const int mu_responder = 15;
/*** Variable declaration ***/
mu_1__type_1 mu_net("net",0);

/*** Variable declaration ***/
mu_1__type_2 mu_atkr("atkr",1040);

/*** Variable declaration ***/
mu_1__type_3 mu_vic("vic",1152);

/*** Variable declaration ***/
mu_1__type_4 mu_compromised_locs("compromised_locs",1232);

/*** Variable declaration ***/
mu_1__type_5 mu_locs_to_explore("locs_to_explore",1240);

mu_1_prob mu_calc_prob(const mu_1_AttackerId& mu_i,const mu_1_AgentStates& mu_c)
{
/*** Variable declaration ***/
mu_1_prob mu_rho("rho",0);

{
  mu_1__type_5& mu_remaining = mu_locs_to_explore;
mu_rho = (1) / (mu_remaining);
cout << "\n1";
mu_locs_to_explore.print();
cout << ( mu_i );
cout << "   to   ";
cout << ( mu_c );
cout << "\n";
switch ((int) mu_atkr[mu_i].mu_state) {
case mu_I_SLEEP:
cout << "case I_SLEEP";
if ( (mu_c) == (mu_I_WAIT) )
{
return (1.000000e+00) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
cout << "case I_SLEEP: returning 0";
return mu_rho;
}
else
{
cout << "returning 0\n";
return 0.000000e+00;
}
}
break;
case mu_I_WAIT:
cout << "case I_WAIT";
if ( (mu_c) == (mu_I_RECV) )
{
cout << "not returning 0";
return ((1.000000e+00) - ((1.000000e+00) / (mu_remaining))) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
cout << "not returning 0";
return (mu_rho) + ((1.000000e+00) / (mu_remaining));
}
else
{
cout << "returning 0";
return 0.000000e+00;
}
}
break;
case mu_I_RECV:
cout << "case I_RECV\n";
if ( (mu_c) == (mu_I_SLEEP) )
{
cout << "I_RECV to I_SLEEP";
return (1.000000e+00) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
cout << "I_RECV to I_KNOW";
cout << "returning rho\n";
return mu_rho;
}
else
{
cout << "I_RECV to OTHER";
cout << "returning 0";
return 0.000000e+00;
}
}
break;
case mu_I_KNOW:
cout << "case I_KNOW";
cout << "returning 0";
return 0.000000e+00;
break;
case mu_R_SLEEP:
cout << "case R_SLEEP";
if ( (mu_c) == (mu_R_RECV) )
{
return (1.000000e+00) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
cout << "returning rho";
return mu_rho;
}
else
{
cout << "returning 0";
return 0.000000e+00;
}
}
break;
case mu_R_RECV:
cout << "case R_RECV";
if ( (mu_c) == (mu_R_SEND) )
{
return (1.000000e+00) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
cout << "returning rho";
return mu_rho;
}
else
{
cout << "returning 0";
return 0.000000e+00;
}
}
break;
case mu_R_SEND:
cout << "case R_SEND";
if ( (mu_c) == (mu_R_SLEEP) )
{
return (1.000000e+00) - (mu_rho);
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
cout << "returning rho";
return mu_rho;
}
else
{
cout << "returning 0";
return 0.000000e+00;
}
}
break;
case mu_R_KNOW:
cout << "case R_KNOW";
cout << "returning 0";
return 0.000000e+00;
break;
}
}
	Error.Error("The end of function calc_prob reached without returning values.");
};
/*** end function declaration ***/

mu_0_boolean mu_send_msg(const mu_1_MessageType& mu_mType,const mu_1_AgentId& mu_source,const mu_1_AgentId& mu_dest,const mu_1_Location& mu_f_a,const mu_1_Location& mu_g_a_b)
{
/*** Variable declaration ***/
mu_1_Message mu_outM("outM",0);

if (mu_source.isundefined())
  mu_outM.mu_source.undefine();
else
  mu_outM.mu_source = mu_source;
if (mu_dest.isundefined())
  mu_outM.mu_dest.undefine();
else
  mu_outM.mu_dest = mu_dest;
if (mu_mType.isundefined())
  mu_outM.mu_mType.undefine();
else
  mu_outM.mu_mType = mu_mType;
if ( (mu_mType) == (mu_From_Init) )
{
if (mu_source.isundefined())
  mu_outM.mu_key.undefine();
else
  mu_outM.mu_key = mu_source;
if (mu_f_a.isundefined())
  mu_outM.mu_f_a.undefine();
else
  mu_outM.mu_f_a = mu_f_a;
}
else
{
if (mu_dest.isundefined())
  mu_outM.mu_key.undefine();
else
  mu_outM.mu_key = mu_dest;
if (mu_g_a_b.isundefined())
  mu_outM.mu_g_a_b.undefine();
else
  mu_outM.mu_g_a_b = mu_g_a_b;
}
/*** begin multisetcount 0 declaration ***/
  int mu__intexpr9 = 0;
  {
  mu_1__type_1_id mu_l;
  for (mu_l = 0; ; mu_l=mu_l+1)
    {
      if (mu_net.valid[(int)mu_l].value())
	{
	  if ( mu_true ) mu__intexpr9++;
	}
      if (mu_l == 10-1) break;
    }
  }
/*** end multisetcount 0 declaration ***/
if ( (mu__intexpr9) < (mu_NetworkSize) )
{
mu_net.multisetadd(mu_outM);
return mu_true;
}
else
{
return mu_false;
}
	Error.Error("The end of function send_msg reached without returning values.");
};
/*** end function declaration ***/

mu_0_boolean mu_recv_msg(const mu_1_MessageType& mu_mType,const mu_1_AgentId& mu_source,const mu_1_AgentId& mu_dest)
{
/*** begin multisetcount 1 declaration ***/
  int mu__intexpr10 = 0;
  {
  mu_1__type_1_id mu_j;
  for (mu_j = 0; ; mu_j=mu_j+1)
    {
      if (mu_net.valid[(int)mu_j].value())
	{
bool mu__boolexpr11;
bool mu__boolexpr12;
  if (!((mu_net[mu_j].mu_source) == (mu_source))) mu__boolexpr12 = FALSE ;
  else {
  mu__boolexpr12 = ((mu_net[mu_j].mu_dest) == (mu_dest)) ; 
}
  if (!(mu__boolexpr12)) mu__boolexpr11 = FALSE ;
  else {
  mu__boolexpr11 = ((mu_net[mu_j].mu_mType) == (mu_mType)) ; 
}
	  if ( mu__boolexpr11 ) mu__intexpr10++;
	}
      if (mu_j == 10-1) break;
    }
  }
/*** end multisetcount 1 declaration ***/
if ( (mu__intexpr10) == (0) )
{
return mu_false;
}
else
{
/*** end multisetremove 0 declaration ***/
  mu_1__type_1_id mu__idexpr13;
  mu_1__type_1_id mu_o;
  for (mu_o = 0; ; mu_o=mu_o+1)
    {
      if (mu_net.valid[(int)mu_o].value())
	{
bool mu__boolexpr14;
bool mu__boolexpr15;
  if (!((mu_net[mu_o].mu_source) == (mu_source))) mu__boolexpr15 = FALSE ;
  else {
  mu__boolexpr15 = ((mu_net[mu_o].mu_dest) == (mu_dest)) ; 
}
  if (!(mu__boolexpr15)) mu__boolexpr14 = FALSE ;
  else {
  mu__boolexpr14 = ((mu_net[mu_o].mu_mType) == (mu_mType)) ; 
}
	  if ( mu__boolexpr14 ) { mu__idexpr13 = mu_o; mu_net.multisetremove(mu__idexpr13); };
	}
      if (mu_o == 10-1) break;
    }
/*** end multisetremove 0 declaration ***/
return mu_true;
}
	Error.Error("The end of function recv_msg reached without returning values.");
};
/*** end function declaration ***/

void mu_step(const mu_1_AttackerId& mu_i, const mu_1_AgentStates& mu_c)
{
/*** Variable declaration ***/
mu_0_boolean mu_change_state("change_state",0);

{
  mu_1_Attacker& mu_attacker = mu_atkr[mu_i];
  mu_1_Victim& mu_victim = mu_vic[mu_atkr[mu_i].mu_other];
  mu_1__type_0& mu_viclist = mu_vic[mu_atkr[mu_i].mu_other].mu_conversation_list;
cout << "step";
switch ((int) mu_attacker.mu_state) {
case mu_I_SLEEP:
if ( (mu_c) == (mu_I_WAIT) )
{
mu_change_state = mu_send_msg( mu_From_Init, (int)mu_i, mu_attacker.mu_other, mu_attacker.mu_location, 1 );
if ( mu_change_state )
{
if (mu_c.isundefined())
  mu_attacker.mu_state.undefine();
else
  mu_attacker.mu_state = mu_c;
cout << "attacker state update to ";
cout << ( mu_c );
cout << "\n";
}
mu_change_state = mu_recv_msg( mu_From_Init, (int)mu_i, mu_attacker.mu_other );
if ( mu_change_state )
{
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_R_RECV;
}
};
};
}
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
mu_attacker.mu_state = mu_I_KNOW;
cout << "attacker state update to ";
cout << ( mu_I_KNOW );
cout << "\n";
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
case mu_I_WAIT:
if ( (mu_c) == (mu_I_RECV) )
{
mu_change_state = mu_send_msg( mu_From_Resp, mu_attacker.mu_other, (int)mu_i, 1, mu_victim.mu_location );
if ( mu_change_state )
{
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_R_SEND;
}
};
};
}
mu_change_state = mu_recv_msg( mu_From_Resp, mu_attacker.mu_other, (int)mu_i );
if ( mu_change_state )
{
mu_attacker.mu_state = mu_I_RECV;
mu_locs_to_explore = (mu_locs_to_explore) - (1);
cout << "2";
mu_locs_to_explore.print();
}
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
mu_attacker.mu_state = mu_I_KNOW;
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
case mu_I_RECV:
if ( (mu_c) == (mu_I_SLEEP) )
{
mu_attacker.mu_state = mu_I_SLEEP;
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_R_SLEEP;
}
};
};
}
else
{
if ( (mu_c) == (mu_I_KNOW) )
{
mu_attacker.mu_state = mu_I_KNOW;
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
case mu_R_SLEEP:
if ( (mu_c) == (mu_R_RECV) )
{
mu_change_state = mu_send_msg( mu_From_Init, mu_attacker.mu_other, (int)mu_i, mu_victim.mu_location, 1 );
if ( mu_change_state )
{
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_I_WAIT;
}
};
};
}
mu_change_state = mu_recv_msg( mu_From_Init, mu_attacker.mu_other, (int)mu_i );
if ( mu_change_state )
{
mu_attacker.mu_state = mu_R_RECV;
}
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
mu_attacker.mu_state = mu_R_KNOW;
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
case mu_R_RECV:
if ( (mu_c) == (mu_R_SEND) )
{
mu_change_state = mu_send_msg( mu_From_Resp, (int)mu_i, mu_attacker.mu_other, 1, mu_attacker.mu_location );
if ( mu_change_state )
{
mu_attacker.mu_state = mu_R_SEND;
}
mu_change_state = mu_recv_msg( mu_From_Resp, (int)mu_i, mu_attacker.mu_other );
if ( mu_change_state )
{
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_I_RECV;
}
};
};
}
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
mu_attacker.mu_state = mu_R_KNOW;
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
case mu_R_SEND:
if ( (mu_c) == (mu_R_SLEEP) )
{
mu_attacker.mu_state = mu_R_SLEEP;
{
for(int mu_p = 1; mu_p <= 2; mu_p++) {
if ( (mu_viclist[mu_p].mu_other) == (mu_i) )
{
mu_viclist[mu_p].mu_state = mu_I_SLEEP;
}
};
};
}
else
{
if ( (mu_c) == (mu_R_KNOW) )
{
mu_attacker.mu_state = mu_R_KNOW;
mu_compromised_locs[mu_attacker.mu_other].mu_loc_found = mu_true;
}
}
break;
}
}
};
/*** end procedure declaration ***/





/********************
  The world
 ********************/
void world_class::clear()
{
  mu_net.clear();
  mu_atkr.clear();
  mu_vic.clear();
  mu_compromised_locs.clear();
  mu_locs_to_explore.clear();
}
void world_class::undefine()
{
  mu_net.undefine();
  mu_atkr.undefine();
  mu_vic.undefine();
  mu_compromised_locs.undefine();
  mu_locs_to_explore.undefine();
}
void world_class::reset()
{
  mu_net.reset();
  mu_atkr.reset();
  mu_vic.reset();
  mu_compromised_locs.reset();
  mu_locs_to_explore.reset();
}
void world_class::print()
{
  static int num_calls = 0; /* to ward off recursive calls. */
  if ( num_calls == 0 ) {
    num_calls++;
  mu_net.print();
  mu_atkr.print();
  mu_vic.print();
  mu_compromised_locs.print();
  mu_locs_to_explore.print();
    num_calls--;
}
}
void world_class::print_statistic()
{
  static int num_calls = 0; /* to ward off recursive calls. */
  if ( num_calls == 0 ) {
    num_calls++;
  mu_net.print_statistic();
  mu_atkr.print_statistic();
  mu_vic.print_statistic();
  mu_compromised_locs.print_statistic();
  mu_locs_to_explore.print_statistic();
    num_calls--;
}
}
void world_class::print_diff( state *prevstate )
{
  if ( prevstate != NULL )
  {
    mu_net.print_diff(prevstate);
    mu_atkr.print_diff(prevstate);
    mu_vic.print_diff(prevstate);
    mu_compromised_locs.print_diff(prevstate);
    mu_locs_to_explore.print_diff(prevstate);
  }
  else
print();
}
void world_class::to_state(state *newstate)
{
  mu_net.to_state( newstate );
  mu_atkr.to_state( newstate );
  mu_vic.to_state( newstate );
  mu_compromised_locs.to_state( newstate );
  mu_locs_to_explore.to_state( newstate );
}
void world_class::setstate(state *thestate)
{
}


/********************
  Rule declarations
 ********************/
/******************** RuleBase0 ********************/
class RuleBase0
{
public:
  int Priority()
  {
    return 0;
  }
  char * Name(unsigned r)
  {
    static mu_1_AgentStates mu_next_state;
    mu_next_state.value((r % 8) + 6);
    r = r / 8;
    static mu_1_AttackerId mu_attacker;
    mu_attacker.value((r % 2) + 1);
    r = r / 2;
    return tsprintf("next, next_state:%s, attacker:%s", mu_next_state.Name(), mu_attacker.Name());
  }
  bool Condition(unsigned r)
  {
    static mu_1_AgentStates mu_next_state;
    mu_next_state.value((r % 8) + 6);
    r = r / 8;
    static mu_1_AttackerId mu_attacker;
    mu_attacker.value((r % 2) + 1);
    r = r / 2;
    return (mu_calc_prob( mu_attacker, mu_next_state ) > 0);
  }

  void NextRule(unsigned & what_rule, double & what_prob)
  {
    unsigned r = what_rule - 0;
    static mu_1_AgentStates mu_next_state;
    mu_next_state.value((r % 8) + 6);
    r = r / 8;
    static mu_1_AttackerId mu_attacker;
    mu_attacker.value((r % 2) + 1);
    r = r / 2;
    while (what_rule < 16 )
      {
	if ( ( TRUE  ) ) {
    what_prob = mu_calc_prob( mu_attacker, mu_next_state );
    if ((what_prob < 0) || (what_prob > 1))
    { 
      Error.Error("Condition of probabilistic rule %s is not in range [0,1].", this->Name(what_rule));
      return;
    }
	      if (what_prob > 0) {
		if ( ( TRUE  ) )
		  return;
		else
		  what_rule++;
	      }
	      else
		what_rule += 1;
	}
	else
	  what_rule += 1;
    r = what_rule - 0;
    mu_next_state.value((r % 8) + 6);
    r = r / 8;
    mu_attacker.value((r % 2) + 1);
    r = r / 2;
    }
  }

  void Code(unsigned r)
  {
    static mu_1_AgentStates mu_next_state;
    mu_next_state.value((r % 8) + 6);
    r = r / 8;
    static mu_1_AttackerId mu_attacker;
    mu_attacker.value((r % 2) + 1);
    r = r / 2;
mu_step ( mu_attacker, mu_next_state );
  };

  bool UnFair()
  { return FALSE; }
};
class NextStateGenerator
{
  RuleBase0 R0;
public:
void SetNextEnabledRule(unsigned & what_rule, double & what_prob)
{
  category = CONDITION;
  if (what_rule<16)
    { R0.NextRule(what_rule, what_prob);
      if (what_rule<16) return; }
}
bool Condition(unsigned r)
{
  category = CONDITION;
  if (r<=15) return R0.Condition(r-0);
Error.Notrace("Internal: NextStateGenerator -- checking condition for nonexisting rule.");
}
void Code(unsigned r)
{
  if (r<=15) { R0.Code(r-0); return; } 
}
int Priority(unsigned short r)
{
  if (r<=15) { return R0.Priority(); } 
}
char * Name(unsigned r)
{
  if (r<=15) return R0.Name(r-0);
  return NULL;
}
};
const unsigned numrules = 16;

/********************
  parameter
 ********************/
#define RULES_IN_WORLD 16


/********************
  Startstate records
 ********************/
/******************** StartStateBase0 ********************/
class StartStateBase0
{
public:
  char * Name(unsigned short r)
  {
    return tsprintf("Startstate 0");
  }
  void Code(unsigned short r)
  {
mu_locs_to_explore.undefine();
mu_locs_to_explore = mu_MaxLocations;
mu_atkr.undefine();
{
for(int mu_i = 1; mu_i <= 2; mu_i++) {
mu_atkr[mu_i].mu_role = mu_initiator;
mu_atkr[mu_i].mu_location = 1;
mu_atkr[mu_i].mu_state = mu_I_SLEEP;
};
};
mu_vic.undefine();
{
for(int mu_i = 3; mu_i <= 3; mu_i++) {
mu_vic[mu_i].mu_location = 1;
{
for(int mu_k = 1; mu_k <= 2; mu_k++) {
mu_vic[mu_i].mu_conversation_list[mu_k].mu_role = mu_responder;
mu_vic[mu_i].mu_conversation_list[mu_k].mu_other = mu_i;
mu_vic[mu_i].mu_conversation_list[mu_k].mu_state = mu_R_SLEEP;
};
};
};
};
{
for(int mu_i = 1; mu_i <= 2; mu_i++) {
{
for(int mu_j = 3; mu_j <= 3; mu_j++) {
mu_atkr[mu_i].mu_other = mu_j;
mu_vic[mu_j].mu_conversation_list[mu_i].mu_other = mu_i;
};
};
};
};
mu_compromised_locs.undefine();
{
for(int mu_i = 3; mu_i <= 3; mu_i++) {
mu_compromised_locs[mu_i].mu_loc_found = mu_false;
};
};
mu_net.undefine();
  };

  bool UnFair()
  { return FALSE; }
};
class StartStateGenerator
{
  StartStateBase0 S0;
public:
void Code(unsigned short r)
{
  if (r<=0) { S0.Code(r-0); return; }
}
char * Name(unsigned short r)
{
  if (r<=0) return S0.Name(r-0);
  return NULL;
}
};
const rulerec startstates[] = {
{ NULL, NULL, NULL, FALSE, 1.0},
};
unsigned short StartStateManager::numstartstates = 1;

/********************
  PCTL formulas records
 ********************/
bool mu_pctl_a_p7()
{
return mu_true;
}
bool mu_pctl_a_p8()
{
bool mu__quant16; 
mu__quant16 = FALSE;
{
for(int mu_v = 3; mu_v <= 3; mu_v++) {
if ( (mu_compromised_locs[mu_v].mu_loc_found) )
  { mu__quant16 = TRUE; break; }
};
};
return mu__quant16;
}
const pctlformrec mu_pctl_formula7 = {
AP_PCTL, &mu_pctl_a_p7, PCTL_L, 0.0, 0, NULL, NULL};
const pctlformrec mu_pctl_formula8 = {
AP_PCTL, &mu_pctl_a_p8, PCTL_L, 0.0, 0, NULL, NULL};
const pctlformrec mu_pctl_formula = {
UNTIL_PCTL, NULL, PCTL_LEQ, 0.001000, 8, &mu_pctl_formula7, &mu_pctl_formula8};
const int mu_pctl_top_untils_form_num = 1;
const pctlformrec *mu_pctl_top_untils_form[] = {&mu_pctl_formula,};

/********************
  Normal/Canonicalization for scalarset
 ********************/
/*
compromised_locs:NoScalarset
locs_to_explore:NoScalarset
atkr:ScalarsetArrayOfScalarset
vic:ScalarsetArrayOfScalarset
net:Complex
*/

/********************
Code for symmetry
 ********************/

/********************
 Permutation Set Class
 ********************/
class PermSet
{
public:
  // book keeping
  enum PresentationType {Simple, Explicit};
  PresentationType Presentation;

  void ResetToSimple();
  void ResetToExplicit();
  void SimpleToExplicit();
  void SimpleToOne();
  bool NextPermutation();

  void Print_in_size()
  { int ret=0; for (int i=0; i<count; i++) if (in[i]) ret++; cout << "in_size:" << ret << "\n"; }


  /********************
   Simple and efficient representation
   ********************/
  int class_mu_1_AttackerId[2];
  int undefined_class_mu_1_AttackerId;// has the highest class number

  void Print_class_mu_1_AttackerId();
  bool OnlyOneRemain_mu_1_AttackerId;
  bool MTO_class_mu_1_AttackerId()
  {
    int i,j;
    if (OnlyOneRemain_mu_1_AttackerId)
      return FALSE;
    for (i=0; i<2; i++)
      for (j=0; j<2; j++)
        if (i!=j && class_mu_1_AttackerId[i]== class_mu_1_AttackerId[j])
	    return TRUE;
    OnlyOneRemain_mu_1_AttackerId = TRUE;
    return FALSE;
  }
  bool AlreadyOnlyOneRemain;
  bool MoreThanOneRemain();


  /********************
   Explicit representation
  ********************/
  unsigned long size;
  unsigned long count;
  // in will be of product of factorial sizes for fast canonicalize
  // in will be of size 1 for reduced local memory canonicalize
  bool * in;

  // auxiliary for explicit representation

  // in/perm/revperm will be of factorial size for fast canonicalize
  // they will be of size 1 for reduced local memory canonicalize
  // second range will be size of the scalarset
  int * in_mu_1_AttackerId;
  typedef int arr_mu_1_AttackerId[2];
  arr_mu_1_AttackerId * perm_mu_1_AttackerId;
  arr_mu_1_AttackerId * revperm_mu_1_AttackerId;

  int size_mu_1_AttackerId[2];
  bool reversed_sorted_mu_1_AttackerId(int start, int end);
  void reverse_reversed_mu_1_AttackerId(int start, int end);

  // procedure for explicit representation
  bool ok0(mu_1_AttackerId* perm, int size, mu_1_AttackerId k);
  void GenPerm0(mu_1_AttackerId* perm, int size, unsigned long& index);

  // General procedure
  PermSet();
  bool In(int i) const { return in[i]; };
  void Add(int i) { for (int j=0; j<i; j++) in[j] = FALSE;};
  void Remove(int i) { in[i] = FALSE; };
};
void PermSet::Print_class_mu_1_AttackerId()
{
  cout << "class_mu_1_AttackerId:\t";
  for (int i=0; i<2; i++)
    cout << class_mu_1_AttackerId[i];
  cout << " " << undefined_class_mu_1_AttackerId << "\n";
}
bool PermSet::MoreThanOneRemain()
{
  int i,j;
  if (AlreadyOnlyOneRemain)
    return FALSE;
  else {
    for (i=0; i<2; i++)
      for (j=0; j<2; j++)
        if (i!=j && class_mu_1_AttackerId[i]== class_mu_1_AttackerId[j])
	    return TRUE;
  }
  AlreadyOnlyOneRemain = TRUE;
  return FALSE;
}
PermSet::PermSet()
: Presentation(Simple)
{
  int i,j,k;
  if (  args->sym_alg.mode == argsym_alg::Exhaustive_Fast_Canonicalize
     || args->sym_alg.mode == argsym_alg::Heuristic_Fast_Canonicalize) {
    mu_1_AttackerId Perm0[2];

  /********************
   declaration of class variables
  ********************/
  in = new bool[2];
 in_mu_1_AttackerId = new int[2];
 perm_mu_1_AttackerId = new arr_mu_1_AttackerId[2];
 revperm_mu_1_AttackerId = new arr_mu_1_AttackerId[2];

    // Set perm and revperm
    count = 0;
    for (i=1; i<=2; i++)
      {
        Perm0[0].value(i);
        GenPerm0(Perm0, 1, count);
      }
    if (count!=2)
      Error.Error( "unable to initialize PermSet");
    for (i=0; i<2; i++)
      for (j=1; j<=2; j++)
        for (k=1; k<=2; k++)
          if (revperm_mu_1_AttackerId[i][k-1]==j)   // k - base 
            perm_mu_1_AttackerId[i][j-1]=k; // j - base 

    // setting up combination of permutations
    // for different scalarset
    int carry;
    int i_mu_1_AttackerId = 0;
    size = 2;
    count = 2;
    for (i=0; i<2; i++)
      {
        carry = 1;
        in[i]= TRUE;
      in_mu_1_AttackerId[i] = i_mu_1_AttackerId;
      i_mu_1_AttackerId += carry;
      if (i_mu_1_AttackerId >= 2) { i_mu_1_AttackerId = 0; carry = 1; } 
      else { carry = 0; } 
    }
  }
  else
  {

  /********************
   declaration of class variables
  ********************/
  in = new bool[1];
 in_mu_1_AttackerId = new int[1];
 perm_mu_1_AttackerId = new arr_mu_1_AttackerId[1];
 revperm_mu_1_AttackerId = new arr_mu_1_AttackerId[1];
  in[0] = TRUE;
    in_mu_1_AttackerId[0] = 0;
  }
}
void PermSet::ResetToSimple()
{
  int i;
  for (i=0; i<2; i++)
    class_mu_1_AttackerId[i]=0;
  undefined_class_mu_1_AttackerId=0;
  OnlyOneRemain_mu_1_AttackerId = FALSE;

  AlreadyOnlyOneRemain = FALSE;
  Presentation = Simple;
}
void PermSet::ResetToExplicit()
{
  for (int i=0; i<2; i++) in[i] = TRUE;
  Presentation = Explicit;
}
void PermSet::SimpleToExplicit()
{
  int i,j,k;
  int start, class_size;
  int start_mu_1_AttackerId[2];
  int size_mu_1_AttackerId[2];
  bool should_be_in_mu_1_AttackerId[2];

  // Setup range for mapping
  start = 0;
  for (j=0; j<=undefined_class_mu_1_AttackerId; j++) // class number
    {
      class_size = 0;
      for (k=0; k<2; k++) // step through class_mu_1_pid[k]
	if (class_mu_1_AttackerId[k]==j)
	  class_size++;
      for (k=0; k<2; k++) // step through class_mu_1_pid[k]
	if (class_mu_1_AttackerId[k]==j)
	  {
	    size_mu_1_AttackerId[k] = class_size;
	    start_mu_1_AttackerId[k] = start;
	  }
      start+=class_size;
    }

  // To be In or not to be
  for (i=0; i<2; i++) // set up
    should_be_in_mu_1_AttackerId[i] = TRUE;
  for (i=0; i<2; i++) // to be in or not to be
    for (k=0; k<2; k++) // step through class_mu_1_pid[k]
      if (! (perm_mu_1_AttackerId[i][k]-1 >=start_mu_1_AttackerId[k] 
	     && perm_mu_1_AttackerId[i][k]-1 < start_mu_1_AttackerId[k] + size_mu_1_AttackerId[k]) )
  	    {
	      should_be_in_mu_1_AttackerId[i] = FALSE;
	      break;
	    }

  // setup explicit representation 
  // Set perm and revperm
  for (i=0; i<2; i++)
    {
      in[i] = TRUE;
      if (in[i] && !should_be_in_mu_1_AttackerId[in_mu_1_AttackerId[i]]) in[i] = FALSE;
    }
  Presentation = Explicit;
  if (args->test_parameter1.value==0) Print_in_size();
}
void PermSet::SimpleToOne()
{
  int i,j,k;
  int class_size;
  int start;


  // Setup range for mapping
  start = 0;
  for (j=0; j<=undefined_class_mu_1_AttackerId; j++) // class number
    {
      class_size = 0;
      for (k=0; k<2; k++) // step through class_mu_1_pid[k]
	if (class_mu_1_AttackerId[k]==j)
	  class_size++;
      for (k=0; k<2; k++) // step through class_mu_1_pid[k]
	if (class_mu_1_AttackerId[k]==j)
	  {
	    size_mu_1_AttackerId[k] = class_size;
	  }
      start+=class_size;
    }
  start = 0;
  for (j=0; j<=undefined_class_mu_1_AttackerId; j++) // class number
    {
      for (k=0; k<2; k++) // step through class_mu_1_pid[k]
	    if (class_mu_1_AttackerId[k]==j)
	      revperm_mu_1_AttackerId[0][start++] = k+1;
    }
  for (j=0; j<2; j++)
    for (k=0; k<2; k++)
      if (revperm_mu_1_AttackerId[0][k]==j+1)
        perm_mu_1_AttackerId[0][j]=k+1;
  Presentation = Explicit;
}
bool PermSet::ok0(mu_1_AttackerId* Perm, int size, mu_1_AttackerId k)
{
  for (int i=0; i<size; i++)
    if(Perm[i].value()==k)
      return FALSE;
  return TRUE;
}
void PermSet::GenPerm0(mu_1_AttackerId* Perm,int size, unsigned long& count)
{
  int i;
  if (size!=2)
    {
      for (i=1; i<=2; i++)
        if(ok0(Perm,size,i))
          {
            Perm[size].value(i);
            GenPerm0(Perm, size+1, count);
          }
    }
  else
    {
      for (i=1; i<=2; i++)
        revperm_mu_1_AttackerId[count][i-1]=Perm[i-1].value();// i - base
      count++;
    }
}
bool PermSet::reversed_sorted_mu_1_AttackerId(int start, int end)
{
  int i,j;

  for (i=start; i<end; i++)
    if (revperm_mu_1_AttackerId[0][i]<revperm_mu_1_AttackerId[0][i+1])
      return FALSE;
  return TRUE;
}
void PermSet::reverse_reversed_mu_1_AttackerId(int start, int end)
{
  int i,j;
  int temp;

  for (i=start, j=end; i<j; i++,j--) 
    {
      temp = revperm_mu_1_AttackerId[0][j];
      revperm_mu_1_AttackerId[0][j] = revperm_mu_1_AttackerId[0][i];
      revperm_mu_1_AttackerId[0][i] = temp;
    }
}
bool PermSet::NextPermutation()
{
  bool nexted = FALSE;
  int start, end; 
  int class_size;
  int temp;
  int j,k;

  // algorithm
  // for each class
  //   if forall in the same class reverse_sorted, 
  //     { sort again; goto next class }
  //   else
  //     {
  //       nexted = TRUE;
  //       for (j from l to r)
  // 	       if (for all j+ are reversed sorted)
  // 	         {
  // 	           swap j, j+1
  // 	           sort all j+ again
  // 	           break;
  // 	         }
  //     }
  for (start = 0; start < 2; )
    {
      end = start-1+size_mu_1_AttackerId[revperm_mu_1_AttackerId[0][start]-1];
      if (reversed_sorted_mu_1_AttackerId(start,end))
	       {
	  reverse_reversed_mu_1_AttackerId(start,end);
	  start = end+1;
	}
      else
	{
	  nexted = TRUE;
	  for (j = start; j<end; j++)
	    {
	      if (reversed_sorted_mu_1_AttackerId(j+1,end))
		{
		  for (k = end; k>j; k--)
		    {
		      if (revperm_mu_1_AttackerId[0][j]<revperm_mu_1_AttackerId[0][k])
			{
			  // swap j, k
			  temp = revperm_mu_1_AttackerId[0][j];
			  revperm_mu_1_AttackerId[0][j] = revperm_mu_1_AttackerId[0][k];
			  revperm_mu_1_AttackerId[0][k] = temp;
			  break;
			}
		    }
		  reverse_reversed_mu_1_AttackerId(j+1,end);
		  break;
		}
	    }
	  break;
	}
    }
if (!nexted) return FALSE;
  for (j=0; j<2; j++)
    for (k=0; k<2; k++)
      if (revperm_mu_1_AttackerId[0][k]==j+1)   // k - base 
	perm_mu_1_AttackerId[0][j]=k+1; // j - base 
  return TRUE;
}

/********************
 Symmetry Class
 ********************/
class SymmetryClass
{
  PermSet Perm;
  bool BestInitialized;
  state BestPermutedState;

  // utilities
  void SetBestResult(int i, state* temp);
  void ResetBestResult() {BestInitialized = FALSE;};

public:
  // initializer
  SymmetryClass() : Perm(), BestInitialized(FALSE) {};
  ~SymmetryClass() {};

  void Normalize(state* s);

  void Exhaustive_Fast_Canonicalize(state *s);
  void Heuristic_Fast_Canonicalize(state *s);
  void Heuristic_Small_Mem_Canonicalize(state *s);
  void Heuristic_Fast_Normalize(state *s);

  void MultisetSort(state* s);
};


/********************
 Symmetry Class Members
 ********************/
void SymmetryClass::MultisetSort(state* s)
{
        mu_compromised_locs.MultisetSort();
        mu_locs_to_explore.MultisetSort();
        mu_atkr.MultisetSort();
        mu_vic.MultisetSort();
        mu_net.MultisetSort();
}
void SymmetryClass::Normalize(state* s)
{
  switch (args->sym_alg.mode) {
  case argsym_alg::Exhaustive_Fast_Canonicalize:
    Exhaustive_Fast_Canonicalize(s);
    break;
  case argsym_alg::Heuristic_Fast_Canonicalize:
    Heuristic_Fast_Canonicalize(s);
    break;
  case argsym_alg::Heuristic_Small_Mem_Canonicalize:
    Heuristic_Small_Mem_Canonicalize(s);
    break;
  case argsym_alg::Heuristic_Fast_Normalize:
    Heuristic_Fast_Normalize(s);
    break;
  default:
    Heuristic_Fast_Canonicalize(s);
  }
}

/********************
 Permute and Canonicalize function for different types
 ********************/
void mu_1_AttackerId::Permute(PermSet& Perm, int i)
{
  if (Perm.Presentation != PermSet::Explicit)
    Error.Error("Internal Error: Wrong Sequence of Normalization");
  if (defined())
    value(Perm.perm_mu_1_AttackerId[Perm.in_mu_1_AttackerId[i]][value()-1]); // value - base
};
void mu_1_AttackerId::SimpleCanonicalize(PermSet& Perm)
{
  int i, class_number;
  if (Perm.Presentation != PermSet::Simple)
    Error.Error("Internal Error: Wrong Sequence of Normalization");

  if (defined())
    if (Perm.class_mu_1_AttackerId[value()-1]==Perm.undefined_class_mu_1_AttackerId) // value - base
      {
        // it has not been mapped to any particular value
        for (i=0; i<2; i++)
          if (Perm.class_mu_1_AttackerId[i] == Perm.undefined_class_mu_1_AttackerId && i!=value()-1)
            Perm.class_mu_1_AttackerId[i]++;
        value(1 + Perm.undefined_class_mu_1_AttackerId++);
      }
    else 
      {
        value(Perm.class_mu_1_AttackerId[value()-1]+1);
      }
}
void mu_1_AttackerId::Canonicalize(PermSet& Perm)
{
  Error.Error("Calling canonicalize() for Scalarset.");
}
void mu_1_AttackerId::SimpleLimit(PermSet& Perm)
{
  int i, class_number;
  if (Perm.Presentation != PermSet::Simple)
    Error.Error("Internal Error: Wrong Sequence of Normalization");

  if (defined())
    if (Perm.class_mu_1_AttackerId[value()-1]==Perm.undefined_class_mu_1_AttackerId) // value - base
      {
        // it has not been mapped to any particular value
        for (i=0; i<2; i++)
          if (Perm.class_mu_1_AttackerId[i] == Perm.undefined_class_mu_1_AttackerId && i!=value()-1)
            Perm.class_mu_1_AttackerId[i]++;
        Perm.undefined_class_mu_1_AttackerId++;
      }
}
void mu_1_AttackerId::ArrayLimit(PermSet& Perm) {}
void mu_1_AttackerId::Limit(PermSet& Perm) {}
void mu_1_AttackerId::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset type.\n"); };
void mu_1_VictimId::Permute(PermSet& Perm, int i) {}
void mu_1_VictimId::SimpleCanonicalize(PermSet& Perm) {}
void mu_1_VictimId::Canonicalize(PermSet& Perm)
{
  Error.Error("Calling canonicalize() for Scalarset.");
}
void mu_1_VictimId::SimpleLimit(PermSet& Perm) {}
void mu_1_VictimId::ArrayLimit(PermSet& Perm) {}
void mu_1_VictimId::Limit(PermSet& Perm) {}
void mu_1_VictimId::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset type.\n"); };
void mu_1_AgentId::Permute(PermSet& Perm, int i)
{
  if (Perm.Presentation != PermSet::Explicit)
    Error.Error("Internal Error: Wrong Sequence of Normalization");
  if (defined()) {
    if ( ( value() >= 1 ) && ( value() <= 2 ) )
      value(Perm.perm_mu_1_AttackerId[Perm.in_mu_1_AttackerId[i]][value()-1]+(0)); // value - base
  }
}
void mu_1_AgentId::SimpleCanonicalize(PermSet& Perm)
{
  int i, class_number;
  if (Perm.Presentation != PermSet::Simple)
    Error.Error("Internal Error: Wrong Sequence of Normalization");
  if (defined()) {
    if ( ( value() >= 1 ) && ( value() <= 2 ) )
      {
        if (Perm.class_mu_1_AttackerId[value()-1]==Perm.undefined_class_mu_1_AttackerId) // value - base
          {
            // it has not been mapped to any particular value
            for (i=0; i<2; i++)
              if (Perm.class_mu_1_AttackerId[i] == Perm.undefined_class_mu_1_AttackerId && i!=value()-1)
                Perm.class_mu_1_AttackerId[i]++;
            value(1 + Perm.undefined_class_mu_1_AttackerId++);
          }
        else 
          {
            value(Perm.class_mu_1_AttackerId[value()-1]+1);
          }
      }
  }
}
void mu_1_AgentId::Canonicalize(PermSet& Perm)
{
  Error.Error("Calling canonicalize() for Scalarset.");
}
void mu_1_AgentId::SimpleLimit(PermSet& Perm)
{
  int i, class_number;
  if (Perm.Presentation != PermSet::Simple)
    Error.Error("Internal Error: Wrong Sequence of Normalization");
  if (defined()) {
    if ( ( value() >= 1 ) && ( value() <= 2 ) )
      if (Perm.class_mu_1_AttackerId[value()-1]==Perm.undefined_class_mu_1_AttackerId) // value - base
        {
          // it has not been mapped to any particular value
          for (i=0; i<2; i++)
            if (Perm.class_mu_1_AttackerId[i] == Perm.undefined_class_mu_1_AttackerId && i!=value()-1)
              Perm.class_mu_1_AttackerId[i]++;
          Perm.undefined_class_mu_1_AttackerId++;
        }
  }
}
void mu_1_AgentId::ArrayLimit(PermSet& Perm) {}
void mu_1_AgentId::Limit(PermSet& Perm) {}
void mu_1_AgentId::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for union type.\n"); };
void mu_1_Location::Permute(PermSet& Perm, int i) {};
void mu_1_Location::SimpleCanonicalize(PermSet& Perm) {};
void mu_1_Location::Canonicalize(PermSet& Perm) {};
void mu_1_Location::SimpleLimit(PermSet& Perm) {};
void mu_1_Location::ArrayLimit(PermSet& Perm) {};
void mu_1_Location::Limit(PermSet& Perm) {};
void mu_1_Location::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for subrange type.\n"); };
void mu_1_prob::Permute(PermSet& Perm, int i) {};
void mu_1_prob::SimpleCanonicalize(PermSet& Perm) {};
void mu_1_prob::Canonicalize(PermSet& Perm) {};
void mu_1_prob::SimpleLimit(PermSet& Perm) {};
void mu_1_prob::ArrayLimit(PermSet& Perm) {};
void mu_1_prob::Limit(PermSet& Perm) {};
void mu_1_prob::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for real type.\n"); };
void mu_1_CompromisedLoc::Permute(PermSet& Perm, int i)
{
};
void mu_1_CompromisedLoc::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Record with no scalarset variable\n"); };
void mu_1_CompromisedLoc::Canonicalize(PermSet& Perm)
{
};
void mu_1_CompromisedLoc::SimpleLimit(PermSet& Perm){}
void mu_1_CompromisedLoc::ArrayLimit(PermSet& Perm){}
void mu_1_CompromisedLoc::Limit(PermSet& Perm)
{
};
void mu_1_CompromisedLoc::MultisetLimit(PermSet& Perm)
{
};
void mu_1_MessageType::Permute(PermSet& Perm, int i) {};
void mu_1_MessageType::SimpleCanonicalize(PermSet& Perm) {};
void mu_1_MessageType::Canonicalize(PermSet& Perm) {};
void mu_1_MessageType::SimpleLimit(PermSet& Perm) {};
void mu_1_MessageType::ArrayLimit(PermSet& Perm) {};
void mu_1_MessageType::Limit(PermSet& Perm) {};
void mu_1_MessageType::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for enum type.\n"); };
void mu_1_Message::Permute(PermSet& Perm, int i)
{
  mu_source.Permute(Perm,i);
  mu_dest.Permute(Perm,i);
  mu_key.Permute(Perm,i);
};
void mu_1_Message::SimpleCanonicalize(PermSet& Perm)
{
  mu_source.SimpleCanonicalize(Perm);
  mu_dest.SimpleCanonicalize(Perm);
  mu_key.SimpleCanonicalize(Perm);
};
void mu_1_Message::Canonicalize(PermSet& Perm)
{
};
void mu_1_Message::SimpleLimit(PermSet& Perm)
{
  mu_source.SimpleLimit(Perm);
  mu_dest.SimpleLimit(Perm);
  mu_key.SimpleLimit(Perm);
};
void mu_1_Message::ArrayLimit(PermSet& Perm){}
void mu_1_Message::Limit(PermSet& Perm)
{
};
void mu_1_Message::MultisetLimit(PermSet& Perm)
{
};
void mu_1_AgentStates::Permute(PermSet& Perm, int i) {};
void mu_1_AgentStates::SimpleCanonicalize(PermSet& Perm) {};
void mu_1_AgentStates::Canonicalize(PermSet& Perm) {};
void mu_1_AgentStates::SimpleLimit(PermSet& Perm) {};
void mu_1_AgentStates::ArrayLimit(PermSet& Perm) {};
void mu_1_AgentStates::Limit(PermSet& Perm) {};
void mu_1_AgentStates::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for enum type.\n"); };
void mu_1_Roles::Permute(PermSet& Perm, int i) {};
void mu_1_Roles::SimpleCanonicalize(PermSet& Perm) {};
void mu_1_Roles::Canonicalize(PermSet& Perm) {};
void mu_1_Roles::SimpleLimit(PermSet& Perm) {};
void mu_1_Roles::ArrayLimit(PermSet& Perm) {};
void mu_1_Roles::Limit(PermSet& Perm) {};
void mu_1_Roles::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for enum type.\n"); };
void mu_1_Attacker::Permute(PermSet& Perm, int i)
{
  mu_other.Permute(Perm,i);
};
void mu_1_Attacker::SimpleCanonicalize(PermSet& Perm)
{
  mu_other.SimpleCanonicalize(Perm);
};
void mu_1_Attacker::Canonicalize(PermSet& Perm)
{
};
void mu_1_Attacker::SimpleLimit(PermSet& Perm)
{
  mu_other.SimpleLimit(Perm);
};
void mu_1_Attacker::ArrayLimit(PermSet& Perm){}
void mu_1_Attacker::Limit(PermSet& Perm)
{
};
void mu_1_Attacker::MultisetLimit(PermSet& Perm)
{
};
void mu_1_Conversation::Permute(PermSet& Perm, int i)
{
  mu_other.Permute(Perm,i);
};
void mu_1_Conversation::SimpleCanonicalize(PermSet& Perm)
{
  mu_other.SimpleCanonicalize(Perm);
};
void mu_1_Conversation::Canonicalize(PermSet& Perm)
{
};
void mu_1_Conversation::SimpleLimit(PermSet& Perm)
{
  mu_other.SimpleLimit(Perm);
};
void mu_1_Conversation::ArrayLimit(PermSet& Perm){}
void mu_1_Conversation::Limit(PermSet& Perm)
{
};
void mu_1_Conversation::MultisetLimit(PermSet& Perm)
{
};
void mu_1__type_0::Permute(PermSet& Perm, int i)
{
  static mu_1__type_0 temp("Permute_mu_1__type_0",-1);
  int j;
  for (j=0; j<2; j++)
    array[j].Permute(Perm, i);
  temp = *this;
  for (j=1; j<=2; j++)
    (*this)[j] = temp[Perm.revperm_mu_1_AttackerId[Perm.in_mu_1_AttackerId[i]][j-1]];};
void mu_1__type_0::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Scalarset Array\n"); };
void mu_1__type_0::Canonicalize(PermSet& Perm){};
void mu_1__type_0::SimpleLimit(PermSet& Perm){}
void mu_1__type_0::ArrayLimit(PermSet& Perm)
{
  // indexes
  int i,j,k,z;
  // sorting
  int count_mu_1_AttackerId;
  int compare;
  static mu_1_Conversation value[2];
  // limit
  bool exists;
  bool split;
  bool goodset_mu_1_AttackerId[2];
  bool pos_mu_1_AttackerId[2][2];
  // sorting mu_1_AttackerId
  // only if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId())
    {
      for (i=0; i<2; i++)
        for (j=0; j<2; j++)
          pos_mu_1_AttackerId[i][j]=FALSE;
      count_mu_1_AttackerId = 0;
      for (i=0; i<2; i++)
        {
          for (j=0; j<count_mu_1_AttackerId; j++)
            {
              compare = CompareWeight(value[j],(*this)[i+1]);
              if (compare==0)
                {
                  pos_mu_1_AttackerId[j][i]= TRUE;
                  break;
                }
              else if (compare>0)
                {
                  for (k=count_mu_1_AttackerId; k>j; k--)
                    {
                      value[k] = value[k-1];
                      for (z=0; z<2; z++)
                        pos_mu_1_AttackerId[k][z] = pos_mu_1_AttackerId[k-1][z];
                    }
                  value[j] = (*this)[i+1];
                  for (z=0; z<2; z++)
                    pos_mu_1_AttackerId[j][z] = FALSE;
                  pos_mu_1_AttackerId[j][i] = TRUE;
                  count_mu_1_AttackerId++;
                  break;
                }
            }
          if (j==count_mu_1_AttackerId)
            {
              value[j] = (*this)[i+1];
              for (z=0; z<2; z++)
                pos_mu_1_AttackerId[j][z] = FALSE;
              pos_mu_1_AttackerId[j][i] = TRUE;
              count_mu_1_AttackerId++;
            }
        }
    }
  // if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId>1)
    {
      // limit
      for (j=0; j<2; j++) // class priority
        {
          for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
            {
              exists = FALSE;
              for (k=0; k<2; k++) // step through class
                goodset_mu_1_AttackerId[k] = FALSE;
              for (k=0; k<2; k++) // step through class
                if (pos_mu_1_AttackerId[i][k] && Perm.class_mu_1_AttackerId[k] == j)
                  {
                    exists = TRUE;
                    goodset_mu_1_AttackerId[k] = TRUE;
                    pos_mu_1_AttackerId[i][k] = FALSE;
                  }
              if (exists)
                {
                  split=FALSE;
                  for (k=0; k<2; k++)
                    if ( Perm.class_mu_1_AttackerId[k] == j && !goodset_mu_1_AttackerId[k] ) 
                      split= TRUE;
                  if (split)
                    {
                      for (k=0; k<2; k++)
                        if (Perm.class_mu_1_AttackerId[k]>j
                            || ( Perm.class_mu_1_AttackerId[k] == j && !goodset_mu_1_AttackerId[k] ) )
                          Perm.class_mu_1_AttackerId[k]++;
                      Perm.undefined_class_mu_1_AttackerId++;
                    }
                }
            }
        }
    }
}
void mu_1__type_0::Limit(PermSet& Perm)
{
  // indexes
  int i,j,k,z;
  // while guard
  bool while_guard, while_guard_temp;
  // sorting
  static mu_1_Conversation value[2];
  // limit
  bool exists;
  bool split;
  int i0;
  int count_mu_1_AttackerId, oldcount_mu_1_AttackerId;
  bool pos_mu_1_AttackerId[2][2];
  bool goodset_mu_1_AttackerId[2];
  // count_ corresponds to the number of equivalence class within the
  // scalarset value.  If count_ == size of the scalarset, then a unique
  // permutation has been found.

  // pos_ is a relation on a equivalence class number and a scalarset value.

  // initializing pos array
  for (i=0; i<2; i++)
    for (j=0; j<2; j++)
      pos_mu_1_AttackerId[i][j]=FALSE;
  count_mu_1_AttackerId = 0;
  while (1)
    {
      exists = FALSE;
      for (i=0; i<2; i++)
       if (Perm.class_mu_1_AttackerId[i] == count_mu_1_AttackerId)
         {
           pos_mu_1_AttackerId[count_mu_1_AttackerId][i]=TRUE;
           exists = TRUE;
         }
      if (exists) count_mu_1_AttackerId++;
      else break;
    }

  // refinement -- check selfloop
  // only if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2)
    {
      exists = FALSE;
      split = FALSE;
      // if there exists both self loop and non-self loop
      for (k=0; k<2; k++) // step through class
        if ((*this)[k+1].mu_other.isundefined()
            ||(*this)[k+1].mu_other!=k+1)
          exists = TRUE;
        else
          split = TRUE;
      if (exists && split)
        {
          for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
            {
              exists = FALSE;
              for (k=0; k<2; k++) // step through class
                goodset_mu_1_AttackerId[k] = FALSE;
              for (k=0; k<2; k++) // step through class
                if (pos_mu_1_AttackerId[i][k] 
                    && !(*this)[k+1].mu_other.isundefined()
                    && (*this)[k+1].mu_other==k+1)
                  {
                    exists = TRUE;
                    goodset_mu_1_AttackerId[k] = TRUE;
                  }
              if (exists)
                {
                  split=FALSE;
                  for (k=0; k<2; k++)
                    if ( pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k] ) 
                          split= TRUE;
                  if (split)
                    {
                      for (j=count_mu_1_AttackerId; j>i; j--)
                        for (k=0; k<2; k++)
                          pos_mu_1_AttackerId[j][k] = pos_mu_1_AttackerId[j-1][k];
                      for (k=0; k<2; k++)
                        {
                          if (pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k])
                            pos_mu_1_AttackerId[i][k] = FALSE;
                          if (pos_mu_1_AttackerId[i+1][k] && goodset_mu_1_AttackerId[k])
                            pos_mu_1_AttackerId[i+1][k] = FALSE;
                        }
                      count_mu_1_AttackerId++; i++;
                    }
                }
            }
        }
    }

  // refinement -- checking priority in general
  while_guard = FALSE;
  while_guard = while_guard || (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2);
  while ( while_guard )
    {
      oldcount_mu_1_AttackerId = count_mu_1_AttackerId;

      // refinement -- graph structure for a single scalarset
      //               as in array S1 of S1
      // only if there is more than 1 permutation in class
      if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2)
        {
          exists = FALSE;
          split = FALSE;
          for (k=0; k<2; k++) // step through class
            if (!(*this)[k+1].mu_other.isundefined()
                &&(*this)[k+1].mu_other!=k+1
                &&(*this)[k+1].mu_other>=1
                &&(*this)[k+1].mu_other<=2)
              exists = TRUE;
          if (exists)
            {
              for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
                {
                  for (j=0; j<count_mu_1_AttackerId; j++) // for value priority
                    {
                      exists = FALSE;
                      for (k=0; k<2; k++) // step through class
                        goodset_mu_1_AttackerId[k] = FALSE;
                      for (k=0; k<2; k++) // step through class
                        if (pos_mu_1_AttackerId[i][k] 
                            && !(*this)[k+1].mu_other.isundefined()
                            && (*this)[k+1].mu_other!=k+1
                            && (*this)[k+1].mu_other>=1
                            && (*this)[k+1].mu_other<=2
                            && pos_mu_1_AttackerId[j][(*this)[k+1].mu_other-1])
                          {
                            exists = TRUE;
                            goodset_mu_1_AttackerId[k] = TRUE;
                          }
                      if (exists)
                        {
                          split=FALSE;
                          for (k=0; k<2; k++)
                            if ( pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k] ) 
                              split= TRUE;
                          if (split)
                            {
                              for (j=count_mu_1_AttackerId; j>i; j--)
                                for (k=0; k<2; k++)
                                  pos_mu_1_AttackerId[j][k] = pos_mu_1_AttackerId[j-1][k];
                              for (k=0; k<2; k++)
                                {
                                  if (pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k])
                                    pos_mu_1_AttackerId[i][k] = FALSE;
                                  if (pos_mu_1_AttackerId[i+1][k] && goodset_mu_1_AttackerId[k])
                                    pos_mu_1_AttackerId[i+1][k] = FALSE;                  
                                }
                              count_mu_1_AttackerId++;
                            }
                        }
                    }
                }
            }
        }
      while_guard = FALSE;
      while_guard = while_guard || (oldcount_mu_1_AttackerId!=count_mu_1_AttackerId);
      while_guard_temp = while_guard;
      while_guard = FALSE;
      while_guard = while_guard || count_mu_1_AttackerId<2;
      while_guard = while_guard && while_guard_temp;
    } // end while
  // enter the result into class
  if (Perm.MTO_class_mu_1_AttackerId())
    {
      for (i=0; i<2; i++)
        for (j=0; j<2; j++)
          if (pos_mu_1_AttackerId[i][j])
            Perm.class_mu_1_AttackerId[j] = i;
      Perm.undefined_class_mu_1_AttackerId=0;
      for (j=0; j<2; j++)
        if (Perm.class_mu_1_AttackerId[j]>Perm.undefined_class_mu_1_AttackerId)
          Perm.undefined_class_mu_1_AttackerId=Perm.class_mu_1_AttackerId[j];
    }
}
void mu_1__type_0::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset array.\n"); };
void mu_1_Victim::Permute(PermSet& Perm, int i)
{
  mu_conversation_list.Permute(Perm,i);
};
void mu_1_Victim::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Record with no scalarset variable\n"); };
void mu_1_Victim::Canonicalize(PermSet& Perm)
{
};
void mu_1_Victim::SimpleLimit(PermSet& Perm){}
void mu_1_Victim::ArrayLimit(PermSet& Perm)
{
  mu_conversation_list.ArrayLimit(Perm);
};
void mu_1_Victim::Limit(PermSet& Perm)
{
  mu_conversation_list.Limit(Perm);
};
void mu_1_Victim::MultisetLimit(PermSet& Perm)
{
};
void mu_1__type_1::Permute(PermSet& Perm, int i)
{
  static mu_1__type_1 temp("Permute_mu_1__type_1",-1);
  int j;
  for (j=0; j<10; j++)
    array[j].Permute(Perm, i);
};
void mu_1__type_1::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: calling SimpleCanonicalize for a multiset.\n"); };
void mu_1__type_1::Canonicalize(PermSet& Perm)
{ Error.Error("You cannot use this symmetry algorithm with Multiset.\n"); };
void mu_1__type_1::SimpleLimit(PermSet& Perm)
{ Error.Error("You cannot use this symmetry algorithm with Multiset.\n"); };
void mu_1__type_1::ArrayLimit(PermSet& Perm)
{ Error.Error("You cannot use this symmetry algorithm with Multiset.\n"); };
void mu_1__type_1::Limit(PermSet& Perm)
{ Error.Error("You cannot use this symmetry algorithm with Multiset.\n"); };
void mu_1__type_1::MultisetLimit(PermSet& Perm)
{
  // indexes
  int i,j,k,z;
  // while guard
  bool while_guard, while_guard_temp;
  // sorting
  static mu_1_Message value[10];
  // limit
  bool exists;
  bool split;
  int i0;
  int count_mu_1_AttackerId, oldcount_mu_1_AttackerId;
  bool pos_mu_1_AttackerId[2][2];
  bool goodset_mu_1_AttackerId[2];
  int count_multisetindex, oldcount_multisetindex;
  bool pos_multisetindex[10][10];
  bool goodset_multisetindex[10];
  mu_1_Message temp;

  // compact
  for (i = 0, j = 0; i < 10; i++)
    if (valid[i].value())
      {
        if (j!=i)
          array[j++] = array[i];
        else
          j++;
      }
  if (j != current_size) current_size = j;
  for (i = j; i < 10; i++)
    array[i].undefine();
  for (i = 0; i < j; i++)
    valid[i].value(TRUE);
  for (i = j; i < 10; i++)
    valid[i].value(FALSE);

  // bubble sort
  for (i = 0; i < current_size; i++)
    for (j = i+1; j < current_size; j++)
      if (CompareWeight(array[i],array[j])>0)
        {
          temp = array[i];
          array[i] = array[j];
          array[j] = temp;
        }
  // initializing pos array
    for (i=0; i<current_size; i++)
      for (j=0; j<current_size; j++)
        pos_multisetindex[i][j]=FALSE;
    count_multisetindex = 1;
    pos_multisetindex[0][0] = TRUE;
    for (i = 1, j = 0 ; i < current_size; i++)
      if (CompareWeight(array[i-1],array[i])==0)
        pos_multisetindex[j][i] = TRUE;
      else
        { count_multisetindex++; pos_multisetindex[++j][i] = TRUE; }
  if (current_size == 1)
    {
      array[0].SimpleLimit(Perm);
    }
  else
    {

  // initializing pos array
  for (i=0; i<2; i++)
    for (j=0; j<2; j++)
      pos_mu_1_AttackerId[i][j]=FALSE;
  count_mu_1_AttackerId = 0;
  while (1)
    {
      exists = FALSE;
      for (i=0; i<2; i++)
       if (Perm.class_mu_1_AttackerId[i] == count_mu_1_AttackerId)
         {
           pos_mu_1_AttackerId[count_mu_1_AttackerId][i]=TRUE;
           exists = TRUE;
         }
      if (exists) count_mu_1_AttackerId++;
      else break;
    }

  // refinement -- checking priority in general
  while_guard = (count_multisetindex < current_size);
  while_guard = while_guard || (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2);
  while ( while_guard )
    {
      oldcount_multisetindex = count_multisetindex;
      oldcount_mu_1_AttackerId = count_mu_1_AttackerId;

      // refinement -- graph structure for two scalarsets
      //               as in array S1 of S2
      // only if there is more than 1 permutation in class
      if ( (count_multisetindex<current_size)
           || ( Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2) )
        {
          exists = FALSE;
          split = FALSE;
          for (k=0; k<current_size; k++) // step through class
            if ((!(*this)[k].mu_source.isundefined())
                && (*this)[k].mu_source>=1
                && (*this)[k].mu_source<=2)
              split = TRUE;
          if (split)
            {
              for (i=0; i<count_multisetindex; i++) // scan through array index priority
                for (j=0; j<count_mu_1_AttackerId; j++) //scan through element priority
                  {
                    exists = FALSE;
                    for (k=0; k<current_size; k++) // initialize goodset
                      goodset_multisetindex[k] = FALSE;
                    for (k=0; k<2; k++) // initialize goodset
                      goodset_mu_1_AttackerId[k] = FALSE;
                    for (k=0; k<current_size; k++) // scan array index
                      // set goodsets
                      if (pos_multisetindex[i][k] 
                          && !(*this)[k].mu_source.isundefined()
                          && (*this)[k].mu_source>=1
                          && (*this)[k].mu_source<=2
                          && pos_mu_1_AttackerId[j][(*this)[k].mu_source-1])
                        {
                          exists = TRUE;
                          goodset_multisetindex[k] = TRUE;
                          goodset_mu_1_AttackerId[(*this)[k].mu_source-1] = TRUE;
                        }
                    if (exists)
                      {
                        // set split for the array index type
                        split=FALSE;
                        for (k=0; k<current_size; k++)
                          if ( pos_multisetindex[i][k] && !goodset_multisetindex[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_multisetindex; z>i; z--)
                              for (k=0; k<current_size; k++)
                                pos_multisetindex[z][k] = pos_multisetindex[z-1][k];
                            // split pos
                            for (k=0; k<current_size; k++)
                              {
                                if (pos_multisetindex[i][k] && !goodset_multisetindex[k])
                                  pos_multisetindex[i][k] = FALSE;
                                if (pos_multisetindex[i+1][k] && goodset_multisetindex[k])
                                  pos_multisetindex[i+1][k] = FALSE;
                              }
                            count_multisetindex++;
                          }
                        // set split for the element type
                        split=FALSE;
                        for (k=0; k<2; k++)
                          if ( pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_mu_1_AttackerId; z>j; z--)
                              for (k=0; k<2; k++)
                                pos_mu_1_AttackerId[z][k] = pos_mu_1_AttackerId[z-1][k];
                            // split pos
                            for (k=0; k<2; k++)
                              {
                                if (pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j][k] = FALSE;
                                if (pos_mu_1_AttackerId[j+1][k] && goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j+1][k] = FALSE;
                              }
                            count_mu_1_AttackerId++;
                          }
                      }
                  }
            }
        }

      // refinement -- graph structure for two scalarsets
      //               as in array S1 of S2
      // only if there is more than 1 permutation in class
      if ( (count_multisetindex<current_size)
           || ( Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2) )
        {
          exists = FALSE;
          split = FALSE;
          for (k=0; k<current_size; k++) // step through class
            if ((!(*this)[k].mu_dest.isundefined())
                && (*this)[k].mu_dest>=1
                && (*this)[k].mu_dest<=2)
              split = TRUE;
          if (split)
            {
              for (i=0; i<count_multisetindex; i++) // scan through array index priority
                for (j=0; j<count_mu_1_AttackerId; j++) //scan through element priority
                  {
                    exists = FALSE;
                    for (k=0; k<current_size; k++) // initialize goodset
                      goodset_multisetindex[k] = FALSE;
                    for (k=0; k<2; k++) // initialize goodset
                      goodset_mu_1_AttackerId[k] = FALSE;
                    for (k=0; k<current_size; k++) // scan array index
                      // set goodsets
                      if (pos_multisetindex[i][k] 
                          && !(*this)[k].mu_dest.isundefined()
                          && (*this)[k].mu_dest>=1
                          && (*this)[k].mu_dest<=2
                          && pos_mu_1_AttackerId[j][(*this)[k].mu_dest-1])
                        {
                          exists = TRUE;
                          goodset_multisetindex[k] = TRUE;
                          goodset_mu_1_AttackerId[(*this)[k].mu_dest-1] = TRUE;
                        }
                    if (exists)
                      {
                        // set split for the array index type
                        split=FALSE;
                        for (k=0; k<current_size; k++)
                          if ( pos_multisetindex[i][k] && !goodset_multisetindex[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_multisetindex; z>i; z--)
                              for (k=0; k<current_size; k++)
                                pos_multisetindex[z][k] = pos_multisetindex[z-1][k];
                            // split pos
                            for (k=0; k<current_size; k++)
                              {
                                if (pos_multisetindex[i][k] && !goodset_multisetindex[k])
                                  pos_multisetindex[i][k] = FALSE;
                                if (pos_multisetindex[i+1][k] && goodset_multisetindex[k])
                                  pos_multisetindex[i+1][k] = FALSE;
                              }
                            count_multisetindex++;
                          }
                        // set split for the element type
                        split=FALSE;
                        for (k=0; k<2; k++)
                          if ( pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_mu_1_AttackerId; z>j; z--)
                              for (k=0; k<2; k++)
                                pos_mu_1_AttackerId[z][k] = pos_mu_1_AttackerId[z-1][k];
                            // split pos
                            for (k=0; k<2; k++)
                              {
                                if (pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j][k] = FALSE;
                                if (pos_mu_1_AttackerId[j+1][k] && goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j+1][k] = FALSE;
                              }
                            count_mu_1_AttackerId++;
                          }
                      }
                  }
            }
        }

      // refinement -- graph structure for two scalarsets
      //               as in array S1 of S2
      // only if there is more than 1 permutation in class
      if ( (count_multisetindex<current_size)
           || ( Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2) )
        {
          exists = FALSE;
          split = FALSE;
          for (k=0; k<current_size; k++) // step through class
            if ((!(*this)[k].mu_key.isundefined())
                && (*this)[k].mu_key>=1
                && (*this)[k].mu_key<=2)
              split = TRUE;
          if (split)
            {
              for (i=0; i<count_multisetindex; i++) // scan through array index priority
                for (j=0; j<count_mu_1_AttackerId; j++) //scan through element priority
                  {
                    exists = FALSE;
                    for (k=0; k<current_size; k++) // initialize goodset
                      goodset_multisetindex[k] = FALSE;
                    for (k=0; k<2; k++) // initialize goodset
                      goodset_mu_1_AttackerId[k] = FALSE;
                    for (k=0; k<current_size; k++) // scan array index
                      // set goodsets
                      if (pos_multisetindex[i][k] 
                          && !(*this)[k].mu_key.isundefined()
                          && (*this)[k].mu_key>=1
                          && (*this)[k].mu_key<=2
                          && pos_mu_1_AttackerId[j][(*this)[k].mu_key-1])
                        {
                          exists = TRUE;
                          goodset_multisetindex[k] = TRUE;
                          goodset_mu_1_AttackerId[(*this)[k].mu_key-1] = TRUE;
                        }
                    if (exists)
                      {
                        // set split for the array index type
                        split=FALSE;
                        for (k=0; k<current_size; k++)
                          if ( pos_multisetindex[i][k] && !goodset_multisetindex[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_multisetindex; z>i; z--)
                              for (k=0; k<current_size; k++)
                                pos_multisetindex[z][k] = pos_multisetindex[z-1][k];
                            // split pos
                            for (k=0; k<current_size; k++)
                              {
                                if (pos_multisetindex[i][k] && !goodset_multisetindex[k])
                                  pos_multisetindex[i][k] = FALSE;
                                if (pos_multisetindex[i+1][k] && goodset_multisetindex[k])
                                  pos_multisetindex[i+1][k] = FALSE;
                              }
                            count_multisetindex++;
                          }
                        // set split for the element type
                        split=FALSE;
                        for (k=0; k<2; k++)
                          if ( pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k] )
                            split= TRUE;
                        if (split)
                          {
                            // move following pos entries down 1 step
                            for (z=count_mu_1_AttackerId; z>j; z--)
                              for (k=0; k<2; k++)
                                pos_mu_1_AttackerId[z][k] = pos_mu_1_AttackerId[z-1][k];
                            // split pos
                            for (k=0; k<2; k++)
                              {
                                if (pos_mu_1_AttackerId[j][k] && !goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j][k] = FALSE;
                                if (pos_mu_1_AttackerId[j+1][k] && goodset_mu_1_AttackerId[k])
                                  pos_mu_1_AttackerId[j+1][k] = FALSE;
                              }
                            count_mu_1_AttackerId++;
                          }
                      }
                  }
            }
        }
      while_guard = oldcount_multisetindex!=count_multisetindex;
      while_guard = while_guard || (oldcount_mu_1_AttackerId!=count_mu_1_AttackerId);
      while_guard_temp = while_guard;
      while_guard = (count_multisetindex < current_size);
      while_guard = while_guard || count_mu_1_AttackerId<2;
      while_guard = while_guard && while_guard_temp;
    } // end while
  // enter the result into class
  if (Perm.MTO_class_mu_1_AttackerId())
    {
      for (i=0; i<2; i++)
        for (j=0; j<2; j++)
          if (pos_mu_1_AttackerId[i][j])
            Perm.class_mu_1_AttackerId[j] = i;
      Perm.undefined_class_mu_1_AttackerId=0;
      for (j=0; j<2; j++)
        if (Perm.class_mu_1_AttackerId[j]>Perm.undefined_class_mu_1_AttackerId)
          Perm.undefined_class_mu_1_AttackerId=Perm.class_mu_1_AttackerId[j];
    }
  }
}
void mu_1__type_2::Permute(PermSet& Perm, int i)
{
  static mu_1__type_2 temp("Permute_mu_1__type_2",-1);
  int j;
  for (j=0; j<2; j++)
    array[j].Permute(Perm, i);
  temp = *this;
  for (j=1; j<=2; j++)
    (*this)[j] = temp[Perm.revperm_mu_1_AttackerId[Perm.in_mu_1_AttackerId[i]][j-1]];};
void mu_1__type_2::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Scalarset Array\n"); };
void mu_1__type_2::Canonicalize(PermSet& Perm){};
void mu_1__type_2::SimpleLimit(PermSet& Perm){}
void mu_1__type_2::ArrayLimit(PermSet& Perm)
{
  // indexes
  int i,j,k,z;
  // sorting
  int count_mu_1_AttackerId;
  int compare;
  static mu_1_Attacker value[2];
  // limit
  bool exists;
  bool split;
  bool goodset_mu_1_AttackerId[2];
  bool pos_mu_1_AttackerId[2][2];
  // sorting mu_1_AttackerId
  // only if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId())
    {
      for (i=0; i<2; i++)
        for (j=0; j<2; j++)
          pos_mu_1_AttackerId[i][j]=FALSE;
      count_mu_1_AttackerId = 0;
      for (i=0; i<2; i++)
        {
          for (j=0; j<count_mu_1_AttackerId; j++)
            {
              compare = CompareWeight(value[j],(*this)[i+1]);
              if (compare==0)
                {
                  pos_mu_1_AttackerId[j][i]= TRUE;
                  break;
                }
              else if (compare>0)
                {
                  for (k=count_mu_1_AttackerId; k>j; k--)
                    {
                      value[k] = value[k-1];
                      for (z=0; z<2; z++)
                        pos_mu_1_AttackerId[k][z] = pos_mu_1_AttackerId[k-1][z];
                    }
                  value[j] = (*this)[i+1];
                  for (z=0; z<2; z++)
                    pos_mu_1_AttackerId[j][z] = FALSE;
                  pos_mu_1_AttackerId[j][i] = TRUE;
                  count_mu_1_AttackerId++;
                  break;
                }
            }
          if (j==count_mu_1_AttackerId)
            {
              value[j] = (*this)[i+1];
              for (z=0; z<2; z++)
                pos_mu_1_AttackerId[j][z] = FALSE;
              pos_mu_1_AttackerId[j][i] = TRUE;
              count_mu_1_AttackerId++;
            }
        }
    }
  // if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId>1)
    {
      // limit
      for (j=0; j<2; j++) // class priority
        {
          for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
            {
              exists = FALSE;
              for (k=0; k<2; k++) // step through class
                goodset_mu_1_AttackerId[k] = FALSE;
              for (k=0; k<2; k++) // step through class
                if (pos_mu_1_AttackerId[i][k] && Perm.class_mu_1_AttackerId[k] == j)
                  {
                    exists = TRUE;
                    goodset_mu_1_AttackerId[k] = TRUE;
                    pos_mu_1_AttackerId[i][k] = FALSE;
                  }
              if (exists)
                {
                  split=FALSE;
                  for (k=0; k<2; k++)
                    if ( Perm.class_mu_1_AttackerId[k] == j && !goodset_mu_1_AttackerId[k] ) 
                      split= TRUE;
                  if (split)
                    {
                      for (k=0; k<2; k++)
                        if (Perm.class_mu_1_AttackerId[k]>j
                            || ( Perm.class_mu_1_AttackerId[k] == j && !goodset_mu_1_AttackerId[k] ) )
                          Perm.class_mu_1_AttackerId[k]++;
                      Perm.undefined_class_mu_1_AttackerId++;
                    }
                }
            }
        }
    }
}
void mu_1__type_2::Limit(PermSet& Perm)
{
  // indexes
  int i,j,k,z;
  // while guard
  bool while_guard, while_guard_temp;
  // sorting
  static mu_1_Attacker value[2];
  // limit
  bool exists;
  bool split;
  int i0;
  int count_mu_1_AttackerId, oldcount_mu_1_AttackerId;
  bool pos_mu_1_AttackerId[2][2];
  bool goodset_mu_1_AttackerId[2];
  // count_ corresponds to the number of equivalence class within the
  // scalarset value.  If count_ == size of the scalarset, then a unique
  // permutation has been found.

  // pos_ is a relation on a equivalence class number and a scalarset value.

  // initializing pos array
  for (i=0; i<2; i++)
    for (j=0; j<2; j++)
      pos_mu_1_AttackerId[i][j]=FALSE;
  count_mu_1_AttackerId = 0;
  while (1)
    {
      exists = FALSE;
      for (i=0; i<2; i++)
       if (Perm.class_mu_1_AttackerId[i] == count_mu_1_AttackerId)
         {
           pos_mu_1_AttackerId[count_mu_1_AttackerId][i]=TRUE;
           exists = TRUE;
         }
      if (exists) count_mu_1_AttackerId++;
      else break;
    }

  // refinement -- check selfloop
  // only if there is more than 1 permutation in class
  if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2)
    {
      exists = FALSE;
      split = FALSE;
      // if there exists both self loop and non-self loop
      for (k=0; k<2; k++) // step through class
        if ((*this)[k+1].mu_other.isundefined()
            ||(*this)[k+1].mu_other!=k+1)
          exists = TRUE;
        else
          split = TRUE;
      if (exists && split)
        {
          for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
            {
              exists = FALSE;
              for (k=0; k<2; k++) // step through class
                goodset_mu_1_AttackerId[k] = FALSE;
              for (k=0; k<2; k++) // step through class
                if (pos_mu_1_AttackerId[i][k] 
                    && !(*this)[k+1].mu_other.isundefined()
                    && (*this)[k+1].mu_other==k+1)
                  {
                    exists = TRUE;
                    goodset_mu_1_AttackerId[k] = TRUE;
                  }
              if (exists)
                {
                  split=FALSE;
                  for (k=0; k<2; k++)
                    if ( pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k] ) 
                          split= TRUE;
                  if (split)
                    {
                      for (j=count_mu_1_AttackerId; j>i; j--)
                        for (k=0; k<2; k++)
                          pos_mu_1_AttackerId[j][k] = pos_mu_1_AttackerId[j-1][k];
                      for (k=0; k<2; k++)
                        {
                          if (pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k])
                            pos_mu_1_AttackerId[i][k] = FALSE;
                          if (pos_mu_1_AttackerId[i+1][k] && goodset_mu_1_AttackerId[k])
                            pos_mu_1_AttackerId[i+1][k] = FALSE;
                        }
                      count_mu_1_AttackerId++; i++;
                    }
                }
            }
        }
    }

  // refinement -- checking priority in general
  while_guard = FALSE;
  while_guard = while_guard || (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2);
  while ( while_guard )
    {
      oldcount_mu_1_AttackerId = count_mu_1_AttackerId;

      // refinement -- graph structure for a single scalarset
      //               as in array S1 of S1
      // only if there is more than 1 permutation in class
      if (Perm.MTO_class_mu_1_AttackerId() && count_mu_1_AttackerId<2)
        {
          exists = FALSE;
          split = FALSE;
          for (k=0; k<2; k++) // step through class
            if (!(*this)[k+1].mu_other.isundefined()
                &&(*this)[k+1].mu_other!=k+1
                &&(*this)[k+1].mu_other>=1
                &&(*this)[k+1].mu_other<=2)
              exists = TRUE;
          if (exists)
            {
              for (i=0; i<count_mu_1_AttackerId; i++) // for value priority
                {
                  for (j=0; j<count_mu_1_AttackerId; j++) // for value priority
                    {
                      exists = FALSE;
                      for (k=0; k<2; k++) // step through class
                        goodset_mu_1_AttackerId[k] = FALSE;
                      for (k=0; k<2; k++) // step through class
                        if (pos_mu_1_AttackerId[i][k] 
                            && !(*this)[k+1].mu_other.isundefined()
                            && (*this)[k+1].mu_other!=k+1
                            && (*this)[k+1].mu_other>=1
                            && (*this)[k+1].mu_other<=2
                            && pos_mu_1_AttackerId[j][(*this)[k+1].mu_other-1])
                          {
                            exists = TRUE;
                            goodset_mu_1_AttackerId[k] = TRUE;
                          }
                      if (exists)
                        {
                          split=FALSE;
                          for (k=0; k<2; k++)
                            if ( pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k] ) 
                              split= TRUE;
                          if (split)
                            {
                              for (j=count_mu_1_AttackerId; j>i; j--)
                                for (k=0; k<2; k++)
                                  pos_mu_1_AttackerId[j][k] = pos_mu_1_AttackerId[j-1][k];
                              for (k=0; k<2; k++)
                                {
                                  if (pos_mu_1_AttackerId[i][k] && !goodset_mu_1_AttackerId[k])
                                    pos_mu_1_AttackerId[i][k] = FALSE;
                                  if (pos_mu_1_AttackerId[i+1][k] && goodset_mu_1_AttackerId[k])
                                    pos_mu_1_AttackerId[i+1][k] = FALSE;                  
                                }
                              count_mu_1_AttackerId++;
                            }
                        }
                    }
                }
            }
        }
      while_guard = FALSE;
      while_guard = while_guard || (oldcount_mu_1_AttackerId!=count_mu_1_AttackerId);
      while_guard_temp = while_guard;
      while_guard = FALSE;
      while_guard = while_guard || count_mu_1_AttackerId<2;
      while_guard = while_guard && while_guard_temp;
    } // end while
  // enter the result into class
  if (Perm.MTO_class_mu_1_AttackerId())
    {
      for (i=0; i<2; i++)
        for (j=0; j<2; j++)
          if (pos_mu_1_AttackerId[i][j])
            Perm.class_mu_1_AttackerId[j] = i;
      Perm.undefined_class_mu_1_AttackerId=0;
      for (j=0; j<2; j++)
        if (Perm.class_mu_1_AttackerId[j]>Perm.undefined_class_mu_1_AttackerId)
          Perm.undefined_class_mu_1_AttackerId=Perm.class_mu_1_AttackerId[j];
    }
}
void mu_1__type_2::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset array.\n"); };
void mu_1__type_3::Permute(PermSet& Perm, int i)
{
  static mu_1__type_3 temp("Permute_mu_1__type_3",-1);
  int j;
  for (j=0; j<1; j++)
    array[j].Permute(Perm, i);
};
void mu_1__type_3::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Scalarset Array\n"); };
void mu_1__type_3::Canonicalize(PermSet& Perm){};
void mu_1__type_3::SimpleLimit(PermSet& Perm){}
void mu_1__type_3::ArrayLimit(PermSet& Perm)
{
  for (int j=0; j<1; j++)
    array[j].ArrayLimit(Perm);
}
void mu_1__type_3::Limit(PermSet& Perm)
{
  if (Perm.Presentation != PermSet::Simple)
    Error.Error("Internal Error: Wrong Sequence of Normalization");

  for (int j=0; j<1; j++) {
    array[j].Limit(Perm);
  }
}
void mu_1__type_3::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset array.\n"); };
void mu_1__type_4::Permute(PermSet& Perm, int i)
{
  static mu_1__type_4 temp("Permute_mu_1__type_4",-1);
  int j;
  for (j=0; j<1; j++)
    array[j].Permute(Perm, i);
};
void mu_1__type_4::SimpleCanonicalize(PermSet& Perm)
{ Error.Error("Internal: Simple Canonicalization of Scalarset Array\n"); };
void mu_1__type_4::Canonicalize(PermSet& Perm){};
void mu_1__type_4::SimpleLimit(PermSet& Perm){}
void mu_1__type_4::ArrayLimit(PermSet& Perm) {}
void mu_1__type_4::Limit(PermSet& Perm){}
void mu_1__type_4::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for scalarset array.\n"); };
void mu_1__type_5::Permute(PermSet& Perm, int i) {};
void mu_1__type_5::SimpleCanonicalize(PermSet& Perm) {};
void mu_1__type_5::Canonicalize(PermSet& Perm) {};
void mu_1__type_5::SimpleLimit(PermSet& Perm) {};
void mu_1__type_5::ArrayLimit(PermSet& Perm) {};
void mu_1__type_5::Limit(PermSet& Perm) {};
void mu_1__type_5::MultisetLimit(PermSet& Perm)
{ Error.Error("Internal: calling MultisetLimit for subrange type.\n"); };

/********************
 Auxiliary function for error trace printing
 ********************/
bool match(state* ns, StatePtr p)
{
  int i;
  static PermSet Perm;
  static state temp;
  StateCopy(&temp, ns);
  if (args->symmetry_reduction.value)
    {
      if (  args->sym_alg.mode == argsym_alg::Exhaustive_Fast_Canonicalize
         || args->sym_alg.mode == argsym_alg::Heuristic_Fast_Canonicalize) {
        Perm.ResetToExplicit();
        for (i=0; i<Perm.count; i++)
          if (Perm.In(i))
            {
              if (ns != workingstate)
                  StateCopy(workingstate, ns);
              
              mu_compromised_locs.Permute(Perm,i);
              if (args->multiset_reduction.value)
                mu_compromised_locs.MultisetSort();
              mu_locs_to_explore.Permute(Perm,i);
              if (args->multiset_reduction.value)
                mu_locs_to_explore.MultisetSort();
              mu_atkr.Permute(Perm,i);
              if (args->multiset_reduction.value)
                mu_atkr.MultisetSort();
              mu_vic.Permute(Perm,i);
              if (args->multiset_reduction.value)
                mu_vic.MultisetSort();
              mu_net.Permute(Perm,i);
              if (args->multiset_reduction.value)
                mu_net.MultisetSort();
            if (p.compare(workingstate)) {
              StateCopy(workingstate,&temp); return TRUE; }
          }
        StateCopy(workingstate,&temp);
        return FALSE;
      }
      else {
        Perm.ResetToSimple();
        Perm.SimpleToOne();
        if (ns != workingstate)
          StateCopy(workingstate, ns);

          mu_compromised_locs.Permute(Perm,0);
          if (args->multiset_reduction.value)
            mu_compromised_locs.MultisetSort();
          mu_locs_to_explore.Permute(Perm,0);
          if (args->multiset_reduction.value)
            mu_locs_to_explore.MultisetSort();
          mu_atkr.Permute(Perm,0);
          if (args->multiset_reduction.value)
            mu_atkr.MultisetSort();
          mu_vic.Permute(Perm,0);
          if (args->multiset_reduction.value)
            mu_vic.MultisetSort();
          mu_net.Permute(Perm,0);
          if (args->multiset_reduction.value)
            mu_net.MultisetSort();
        if (p.compare(workingstate)) {
          StateCopy(workingstate,&temp); return TRUE; }

        while (Perm.NextPermutation())
          {
            if (ns != workingstate)
              StateCopy(workingstate, ns);
              
              mu_compromised_locs.Permute(Perm,0);
              if (args->multiset_reduction.value)
                mu_compromised_locs.MultisetSort();
              mu_locs_to_explore.Permute(Perm,0);
              if (args->multiset_reduction.value)
                mu_locs_to_explore.MultisetSort();
              mu_atkr.Permute(Perm,0);
              if (args->multiset_reduction.value)
                mu_atkr.MultisetSort();
              mu_vic.Permute(Perm,0);
              if (args->multiset_reduction.value)
                mu_vic.MultisetSort();
              mu_net.Permute(Perm,0);
              if (args->multiset_reduction.value)
                mu_net.MultisetSort();
            if (p.compare(workingstate)) {
              StateCopy(workingstate,&temp); return TRUE; }
          }
        StateCopy(workingstate,&temp);
        return FALSE;
      }
    }
  if (!args->symmetry_reduction.value
      && args->multiset_reduction.value)
    {
      if (ns != workingstate)
          StateCopy(workingstate, ns);
      mu_compromised_locs.MultisetSort();
      mu_locs_to_explore.MultisetSort();
      mu_atkr.MultisetSort();
      mu_vic.MultisetSort();
      mu_net.MultisetSort();
      if (p.compare(workingstate)) {
        StateCopy(workingstate,&temp); return TRUE; }
      StateCopy(workingstate,&temp);
      return FALSE;
    }
  return (p.compare(ns));
}

/********************
 Canonicalization by fast exhaustive generation of
 all permutations
 ********************/
void SymmetryClass::Exhaustive_Fast_Canonicalize(state* s)
{
  int i;
  static state temp;
  Perm.ResetToExplicit();

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_compromised_locs.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_compromised_locs.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_locs_to_explore.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_locs_to_explore.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_atkr.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_atkr.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_vic.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_vic.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_net.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_net.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

};

/********************
 Canonicalization by fast simple variable canonicalization,
 fast simple scalarset array canonicalization,
 fast restriction on permutation set with simple scalarset array of scalarset,
 and fast exhaustive generation of
 all permutations for other variables
 ********************/
void SymmetryClass::Heuristic_Fast_Canonicalize(state* s)
{
  int i;
  static state temp;

  Perm.ResetToSimple();

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_net.MultisetLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.Limit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.Limit(Perm);
  }

  Perm.SimpleToExplicit();

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_atkr.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_atkr.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_vic.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_vic.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

  StateCopy(&temp, workingstate);
  ResetBestResult();
  for (i=0; i<Perm.count; i++)
    if (Perm.In(i))
      {
        StateCopy(workingstate, &temp);
        mu_net.Permute(Perm,i);
        if (args->multiset_reduction.value)
          mu_net.MultisetSort();
        SetBestResult(i, workingstate);
      }
  StateCopy(workingstate, &BestPermutedState);

};

/********************
 Canonicalization by fast simple variable canonicalization,
 fast simple scalarset array canonicalization,
 fast restriction on permutation set with simple scalarset array of scalarset,
 and fast exhaustive generation of
 all permutations for other variables
 and use less local memory
 ********************/
void SymmetryClass::Heuristic_Small_Mem_Canonicalize(state* s)
{
  unsigned long cycle;
  static state temp;

  Perm.ResetToSimple();

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_net.MultisetLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.Limit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.Limit(Perm);
  }

  Perm.SimpleToOne();

  StateCopy(&temp, workingstate);
  ResetBestResult();
  mu_atkr.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_atkr.MultisetSort();
  mu_vic.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_vic.MultisetSort();
  mu_net.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_net.MultisetSort();
  BestPermutedState = *workingstate;
  BestInitialized = TRUE;

  cycle=1;
  while (Perm.NextPermutation())
    {
      if (args->perm_limit.value != 0
          && cycle++ >= args->perm_limit.value) break;
      StateCopy(workingstate, &temp);
      mu_atkr.Permute(Perm,0);
      if (args->multiset_reduction.value)
        mu_atkr.MultisetSort();
      mu_vic.Permute(Perm,0);
      if (args->multiset_reduction.value)
        mu_vic.MultisetSort();
      mu_net.Permute(Perm,0);
      if (args->multiset_reduction.value)
        mu_net.MultisetSort();
      switch (StateCmp(workingstate, &BestPermutedState)) {
      case -1:
        BestPermutedState = *workingstate;
        break;
      case 1:
        break;
      case 0:
        break;
      default:
        Error.Error("funny return value from StateCmp");
      }
    }
  StateCopy(workingstate, &BestPermutedState);

};

/********************
 Normalization by fast simple variable canonicalization,
 fast simple scalarset array canonicalization,
 fast restriction on permutation set with simple scalarset array of scalarset,
 and for all other variables, pick any remaining permutation
 ********************/
void SymmetryClass::Heuristic_Fast_Normalize(state* s)
{
  int i;
  static state temp;

  Perm.ResetToSimple();

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.ArrayLimit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_atkr.Limit(Perm);
  }

  if (Perm.MoreThanOneRemain()) {
    mu_vic.Limit(Perm);
  }

  Perm.SimpleToOne();

  mu_atkr.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_atkr.MultisetSort();

  mu_vic.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_vic.MultisetSort();

  mu_net.Permute(Perm,0);
  if (args->multiset_reduction.value)
    mu_net.MultisetSort();

};

/********************
  Include
 ********************/
#include "mu_epilog.inc"
